import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Pipe, inject, ChangeDetectorRef, Component, Input } from '@angular/core';
import { MatIconModule } from '@angular/material/icon';
import moment from 'moment';
import { g as get, d as duration } from './eherve-angular-material-datatable-eherve-angular-material-datatable-PWxHXOMs.mjs';

/** @format */
class MomentFormatPipe {
    transform(data, options) {
        const date = this.getMoment(data);
        if (!date)
            return '';
        const format = options?.format || 'LLL';
        return options?.locale ? date.locale(options.locale).format(format) : date.format(format);
    }
    getMoment(data) {
        if (typeof data === 'string')
            return moment(data);
        if (typeof data === 'number')
            return moment(data);
        if (data instanceof Date)
            return moment(data);
        if (moment.isMoment(data))
            return data.clone();
        if (typeof data?.valueOf === 'function') {
            const value = data.valueOf();
            if (typeof value === 'number')
                return moment(data);
        }
        return null;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: MomentFormatPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.0.4", ngImport: i0, type: MomentFormatPipe, isStandalone: true, name: "momentFormat" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: MomentFormatPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'momentFormat' }]
        }] });

/** @format */
class CellDateValueComponent {
    changeDetectorRef = inject(ChangeDetectorRef);
    column;
    set setRow(row) {
        this.row = row;
        this.value = get(this.row, this.column.property);
        if (typeof this.column.transform === 'function') {
            this.value = this.column.transform(this.value, this.row);
        }
        this.duration = duration(this.value, this.column);
    }
    row;
    value;
    duration;
    refreshInterval;
    ngOnInit() {
        if (this.column.durationRefreshTime) {
            this.refreshInterval = setInterval(() => {
                this.duration = duration(this.value, this.column);
                this.changeDetectorRef.detectChanges();
            }, this.column.durationRefreshTime);
        }
    }
    ngOnDestroy() {
        if (this.refreshInterval)
            clearInterval(this.refreshInterval);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: CellDateValueComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.4", type: CellDateValueComponent, isStandalone: true, selector: "lib-cell-date-value", inputs: { column: "column", setRow: ["row", "setRow"] }, ngImport: i0, template: "<!-- @format -->\n\n@if (value) {\n  <span class=\"date\"> {{ value | momentFormat: column }} </span>\n  @if (column.withDuration) {\n    <span class=\"duration\"> ({{ duration }}) </span>\n  }\n}\n", styles: [".date,.duration{white-space:nowrap}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "ngmodule", type: MatIconModule }, { kind: "pipe", type: MomentFormatPipe, name: "momentFormat" }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: CellDateValueComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-cell-date-value', imports: [CommonModule, MatIconModule, MomentFormatPipe], template: "<!-- @format -->\n\n@if (value) {\n  <span class=\"date\"> {{ value | momentFormat: column }} </span>\n  @if (column.withDuration) {\n    <span class=\"duration\"> ({{ duration }}) </span>\n  }\n}\n", styles: [".date,.duration{white-space:nowrap}\n"] }]
        }], propDecorators: { column: [{
                type: Input
            }], setRow: [{
                type: Input,
                args: ['row']
            }] } });

export { CellDateValueComponent };
//# sourceMappingURL=eherve-angular-material-datatable-cell-date-value.component-DAZd-ntE.mjs.map
