import * as i0 from '@angular/core';
import { Pipe, inject, Injector, ChangeDetectorRef, forwardRef, Component, Input, ViewChild, signal, ChangeDetectionStrategy, LOCALE_ID, Injectable, HostBinding, Directive, EventEmitter, Output, ContentChildren, NgModule } from '@angular/core';
import { trigger, transition, style, animate } from '@angular/animations';
import * as i2$1 from '@angular/cdk/drag-drop';
import { moveItemInArray, DragDropModule } from '@angular/cdk/drag-drop';
import * as i1$1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i2 from '@angular/forms';
import { FormControl, NgControl, NG_VALUE_ACCESSOR, FormsModule, ReactiveFormsModule, FormGroup, Validators } from '@angular/forms';
import * as i5$2 from '@angular/material/badge';
import { MatBadgeModule } from '@angular/material/badge';
import * as i3$1 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i14 from '@angular/material/card';
import { MatCardModule } from '@angular/material/card';
import * as i4$1 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i5$1 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i9 from '@angular/material/menu';
import { MatMenuModule } from '@angular/material/menu';
import * as i10$1 from '@angular/material/paginator';
import { MatPaginatorIntl, MatPaginator, MatPaginatorModule } from '@angular/material/paginator';
import * as i1$3 from '@angular/material/progress-spinner';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import * as i12 from '@angular/material/table';
import { MatTableModule } from '@angular/material/table';
import * as i13 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import * as i3$3 from 'ngx-countup';
import { CountUpModule } from 'ngx-countup';
import * as i3 from 'ngx-intersection-observer';
import { IntersectionObserverModule } from 'ngx-intersection-observer';
import { BehaviorSubject, Subject, Subscription, filter, debounceTime, switchMap, startWith, tap, map, lastValueFrom } from 'rxjs';
import * as XLSX from 'xlsx';
import * as i4 from '@angular/material/autocomplete';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import * as i6 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i10 from '@angular/material/progress-bar';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import * as i1 from '@angular/platform-browser';
import * as i5 from '@angular/material/core';
import { DateAdapter, MAT_DATE_LOCALE } from '@angular/material/core';
import * as i3$2 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { provideMomentDateAdapter } from '@angular/material-moment-adapter';
import * as i4$2 from '@angular/material/datepicker';
import { MatDatepickerIntl, MatDatepickerModule } from '@angular/material/datepicker';
import moment from 'moment';
import * as i1$2 from '@angular/cdk/overlay';
import { OverlayModule } from '@angular/cdk/overlay';
import * as i6$1 from '@angular/material/select';
import { MatSelectModule } from '@angular/material/select';
import { DataSource } from '@angular/cdk/collections';
import humanizeDuration from 'humanize-duration';

/** @format */
class SafeHtmlPipe {
    sanitizer;
    constructor(sanitizer) {
        this.sanitizer = sanitizer;
    }
    transform(html) {
        return this.sanitizer.bypassSecurityTrustHtml(html);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: SafeHtmlPipe, deps: [{ token: i1.DomSanitizer }], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.0.4", ngImport: i0, type: SafeHtmlPipe, isStandalone: true, name: "safeHtml" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: SafeHtmlPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'safeHtml',
                }]
        }], ctorParameters: () => [{ type: i1.DomSanitizer }] });

var safeHtml_pipe = /*#__PURE__*/Object.freeze({
    __proto__: null,
    SafeHtmlPipe: SafeHtmlPipe
});

/** @format */
class HeaderAutocompleteFilterComponent {
    column;
    options = [];
    hasMore = false;
    searching = false;
    input;
    control;
    selectControl = new FormControl();
    onChange = () => { };
    onTouched = () => { };
    filter$ = new BehaviorSubject(undefined);
    nextPage$ = new Subject();
    injector = inject(Injector);
    changeDetectorRef = inject(ChangeDetectorRef);
    subsink = new Subscription();
    writeValue = (value) => {
        if (value?.value !== this.selectControl.value)
            this.selectControl.setValue(value?.value);
    };
    registerOnChange(onChange) {
        this.onChange = onChange;
    }
    registerOnTouched(onTouched) {
        this.onTouched = onTouched;
    }
    async ngAfterViewInit() {
        const ngControl = this.injector.get(NgControl, null);
        if (!ngControl)
            throw new Error(`${this.constructor.name} missing control [column:${this.column.columnDef}]`);
        this.control = ngControl.control;
        this.subsink.add(this.selectControl.valueChanges.subscribe((value) => {
            if (value === undefined) {
                if (this.control.value !== undefined)
                    this.control.setValue(undefined);
            }
            if (value === null && !this.options.find(o => o.value === null)) {
                if (this.control.value !== undefined)
                    this.control.setValue(undefined);
            }
            else if (this.control.value?.value !== value)
                this.control.setValue({ value, regex: false });
        }));
        this.buildOptions();
        this.changeDetectorRef.detectChanges();
    }
    ngOnDestroy() {
        this.subsink.unsubscribe();
    }
    loadMore(intersect) {
        if (!intersect)
            return;
        this.nextPage$.next();
    }
    focus() {
        if (this.column.loadOnFocus) {
            const search = this.input.nativeElement.value;
            if (this.filter$.value !== search)
                this.filter$.next(search);
        }
    }
    filter() {
        const search = this.input.nativeElement.value;
        this.filter$.next(search);
    }
    buildOptions() {
        this.subsink.add(this.filter$
            .pipe(filter(value => typeof value === 'string'), debounceTime(300), switchMap((search) => {
            this.options = [];
            let skip = 0;
            return this.nextPage$.pipe(startWith(skip), tap(() => (this.searching = true)), switchMap(async () => this.column.options(this.column.limit || 10, skip, search)), map(data => {
                this.options.push(...data);
                skip += this.column.limit || 10;
                this.hasMore = data?.length === (this.column.limit || 10);
                this.searching = false;
            }));
        }))
            .subscribe());
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderAutocompleteFilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.4", type: HeaderAutocompleteFilterComponent, isStandalone: true, selector: "lib-header-autocomplete-filter", inputs: { column: "column" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: forwardRef(() => HeaderAutocompleteFilterComponent),
            },
        ], viewQueries: [{ propertyName: "input", first: true, predicate: ["input"], descendants: true }], ngImport: i0, template: "<!-- @format -->\n\n@if (selectControl) {\n  <mat-form-field appearance=\"fill\">\n    <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n    <input\n      #input\n      type=\"text\"\n      [placeholder]=\"column.placeholder!\"\n      aria-label=\"Number\"\n      matInput\n      [formControl]=\"selectControl\"\n      [matAutocomplete]=\"auto\"\n      (input)=\"filter()\"\n      (focus)=\"focus()\" />\n    <mat-autocomplete #auto=\"matAutocomplete\" requireSelection>\n      @for (option of options; track option) {\n        <mat-option [value]=\"option.value\">\n          <ng-container *ngTemplateOutlet=\"autocompleteOption; context: { option }\"></ng-container>\n        </mat-option>\n      }\n\n      <mat-option id=\"searching-option\" disabled>\n        @if (searching) {\n          <mat-progress-bar mode=\"indeterminate\"></mat-progress-bar>\n        }\n      </mat-option>\n\n      @if (hasMore && !searching) {\n        <mat-option id=\"load-more-options\" disabled intersectionObserver (intersection)=\"loadMore($event.intersect)\">\n        </mat-option>\n      }\n    </mat-autocomplete>\n\n    <button\n      *ngIf=\"selectControl.value\"\n      mat-icon-button\n      matSuffix\n      size=\"small\"\n      (click)=\"selectControl.setValue(undefined)\">\n      <mat-icon>close</mat-icon>\n    </button>\n  </mat-form-field>\n}\n\n<ng-template #autocompleteOption let-option=\"option\">\n  <div class=\"option\">\n    @if (option.icon) {\n      <mat-icon [style.color]=\"option.iconColor\" [style.margin-right.px]=\"8\">\n        {{ option.icon }}\n      </mat-icon>\n    }\n    <mat-label [style.color]=\"option.color\" [innerHTML]=\"option.name | safeHtml\"></mat-label>\n  </div>\n</ng-template>\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}.option{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row}#searching-option{min-height:2px;position:relative}#searching-option mat-progress-bar{position:absolute;inset:0}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "ngmodule", type: IntersectionObserverModule }, { kind: "directive", type: i3.IntersectionObserverDirective, selector: "[intersectionObserver]", inputs: ["visitClass", "leaveClass", "removeVisitClass", "removeLeaveClass", "useScroll", "threshold", "autoRemove"], outputs: ["intersection"] }, { kind: "ngmodule", type: MatAutocompleteModule }, { kind: "component", type: i4.MatAutocomplete, selector: "mat-autocomplete", inputs: ["aria-label", "aria-labelledby", "displayWith", "autoActiveFirstOption", "autoSelectActiveOption", "requireSelection", "panelWidth", "disableRipple", "class", "hideSingleSelectionIndicator"], outputs: ["optionSelected", "opened", "closed", "optionActivated"], exportAs: ["matAutocomplete"] }, { kind: "component", type: i5.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "directive", type: i4.MatAutocompleteTrigger, selector: "input[matAutocomplete], textarea[matAutocomplete]", inputs: ["matAutocomplete", "matAutocompletePosition", "matAutocompleteConnectedTo", "autocomplete", "matAutocompleteDisabled"], exportAs: ["matAutocompleteTrigger"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$1.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$1.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i5$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i6.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "ngmodule", type: MatProgressBarModule }, { kind: "component", type: i10.MatProgressBar, selector: "mat-progress-bar", inputs: ["color", "value", "bufferValue", "mode"], outputs: ["animationEnd"], exportAs: ["matProgressBar"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "pipe", type: SafeHtmlPipe, name: "safeHtml" }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderAutocompleteFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-header-autocomplete-filter', imports: [
                        CommonModule,
                        FormsModule,
                        IntersectionObserverModule,
                        MatAutocompleteModule,
                        MatButtonModule,
                        MatFormFieldModule,
                        MatIconModule,
                        MatInputModule,
                        MatProgressBarModule,
                        ReactiveFormsModule,
                        SafeHtmlPipe,
                    ], providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: forwardRef(() => HeaderAutocompleteFilterComponent),
                        },
                    ], template: "<!-- @format -->\n\n@if (selectControl) {\n  <mat-form-field appearance=\"fill\">\n    <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n    <input\n      #input\n      type=\"text\"\n      [placeholder]=\"column.placeholder!\"\n      aria-label=\"Number\"\n      matInput\n      [formControl]=\"selectControl\"\n      [matAutocomplete]=\"auto\"\n      (input)=\"filter()\"\n      (focus)=\"focus()\" />\n    <mat-autocomplete #auto=\"matAutocomplete\" requireSelection>\n      @for (option of options; track option) {\n        <mat-option [value]=\"option.value\">\n          <ng-container *ngTemplateOutlet=\"autocompleteOption; context: { option }\"></ng-container>\n        </mat-option>\n      }\n\n      <mat-option id=\"searching-option\" disabled>\n        @if (searching) {\n          <mat-progress-bar mode=\"indeterminate\"></mat-progress-bar>\n        }\n      </mat-option>\n\n      @if (hasMore && !searching) {\n        <mat-option id=\"load-more-options\" disabled intersectionObserver (intersection)=\"loadMore($event.intersect)\">\n        </mat-option>\n      }\n    </mat-autocomplete>\n\n    <button\n      *ngIf=\"selectControl.value\"\n      mat-icon-button\n      matSuffix\n      size=\"small\"\n      (click)=\"selectControl.setValue(undefined)\">\n      <mat-icon>close</mat-icon>\n    </button>\n  </mat-form-field>\n}\n\n<ng-template #autocompleteOption let-option=\"option\">\n  <div class=\"option\">\n    @if (option.icon) {\n      <mat-icon [style.color]=\"option.iconColor\" [style.margin-right.px]=\"8\">\n        {{ option.icon }}\n      </mat-icon>\n    }\n    <mat-label [style.color]=\"option.color\" [innerHTML]=\"option.name | safeHtml\"></mat-label>\n  </div>\n</ng-template>\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}.option{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row}#searching-option{min-height:2px;position:relative}#searching-option mat-progress-bar{position:absolute;inset:0}\n"] }]
        }], propDecorators: { column: [{
                type: Input
            }], input: [{
                type: ViewChild,
                args: ['input']
            }] } });

/** @format */
class HeaderCheckboxFilterComponent {
    column;
    control;
    selectControl = new FormControl();
    onChange = () => { };
    onTouched = () => { };
    injector = inject(Injector);
    changeDetectorRef = inject(ChangeDetectorRef);
    subsink = new Subscription();
    writeValue = (value) => {
        if (value?.value !== this.selectControl.value)
            this.selectControl.setValue(value?.value);
    };
    registerOnChange(onChange) {
        this.onChange = onChange;
    }
    registerOnTouched(onTouched) {
        this.onTouched = onTouched;
    }
    async ngAfterViewInit() {
        const ngControl = this.injector.get(NgControl, null);
        if (!ngControl)
            throw new Error(`${this.constructor.name} missing control [column:${this.column.columnDef}]`);
        this.control = ngControl.control;
        let previousValue = this.control.value;
        this.subsink.add(this.selectControl.valueChanges
            .pipe(filter(value => {
            if (value === true && previousValue === false) {
                this.selectControl.setValue(undefined);
                return false;
            }
            return true;
        }), tap(value => (previousValue = value)))
            .subscribe((value) => {
            if (value === undefined)
                this.control.setValue(undefined);
            else
                this.control.setValue({ value, regex: false });
        }));
        this.changeDetectorRef.detectChanges();
    }
    ngOnDestroy() {
        this.subsink.unsubscribe();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderCheckboxFilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.4", type: HeaderCheckboxFilterComponent, isStandalone: true, selector: "lib-header-checkbox-filter", inputs: { column: "column" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: forwardRef(() => HeaderCheckboxFilterComponent),
            },
        ], ngImport: i0, template: "<!-- @format -->\n\n@if (selectControl) {\n  <mat-checkbox [formControl]=\"selectControl\" [indeterminate]=\"selectControl.value === undefined\">\n    <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n  </mat-checkbox>\n}\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}.option{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "ngmodule", type: MatButtonModule }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "directive", type: i4$1.MatLabel, selector: "mat-label" }, { kind: "ngmodule", type: MatIconModule }, { kind: "ngmodule", type: MatCheckboxModule }, { kind: "component", type: i3$2.MatCheckbox, selector: "mat-checkbox", inputs: ["aria-label", "aria-labelledby", "aria-describedby", "aria-expanded", "aria-controls", "aria-owns", "id", "required", "labelPosition", "name", "value", "disableRipple", "tabIndex", "color", "disabledInteractive", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "pipe", type: SafeHtmlPipe, name: "safeHtml" }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderCheckboxFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-header-checkbox-filter', imports: [
                        CommonModule,
                        FormsModule,
                        MatButtonModule,
                        MatFormFieldModule,
                        MatIconModule,
                        MatCheckboxModule,
                        ReactiveFormsModule,
                        SafeHtmlPipe,
                    ], providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: forwardRef(() => HeaderCheckboxFilterComponent),
                        },
                    ], template: "<!-- @format -->\n\n@if (selectControl) {\n  <mat-checkbox [formControl]=\"selectControl\" [indeterminate]=\"selectControl.value === undefined\">\n    <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n  </mat-checkbox>\n}\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}.option{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row}\n"] }]
        }], propDecorators: { column: [{
                type: Input
            }] } });

/** @format */
const OPERATORS = ['=', '>', '≥', '<', '≤', '<>', '≤≥'];
class OperatorSelectComponent {
    set setDisableRange(disableRange) {
        this.disableRange = disableRange !== false;
        if (this.disableRange)
            this.operators = OPERATORS.slice(0, 5);
        else
            this.operators = OPERATORS;
    }
    disableRange = false;
    operators = OPERATORS;
    isOpen = false;
    control;
    onChange = () => { };
    onTouched = () => { };
    injector = inject(Injector);
    changeDetectorRef = inject(ChangeDetectorRef);
    writeValue = () => { };
    registerOnChange(onChange) {
        this.onChange = onChange;
    }
    registerOnTouched(onTouched) {
        this.onTouched = onTouched;
    }
    async ngAfterViewInit() {
        const ngControl = this.injector.get(NgControl, null);
        if (!ngControl)
            throw new Error(`${this.constructor.name} missing control`);
        this.control = ngControl.control;
        this.changeDetectorRef.detectChanges();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: OperatorSelectComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.4", type: OperatorSelectComponent, isStandalone: true, selector: "lib-operator-select", inputs: { setDisableRange: ["disableRange", "setDisableRange"] }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: forwardRef(() => OperatorSelectComponent),
            },
        ], ngImport: i0, template: "<!-- @format -->\n\n@if (control) {\n  <button\n    mat-mini-fab\n    color=\"primary\"\n    class=\"ngx-mat-datatable-operator-button\"\n    cdkOverlayOrigin\n    #trigger=\"cdkOverlayOrigin\"\n    (click)=\"$event.stopPropagation(); isOpen = !isOpen\">\n    {{ control.value }}\n  </button>\n\n  <ng-template cdkConnectedOverlay [cdkConnectedOverlayOrigin]=\"trigger\" [cdkConnectedOverlayOpen]=\"isOpen\">\n    <div class=\"ngx-mat-datatable-operator-column\" @fade>\n      @for (operator of operators; track operator) {\n        @if (operator !== control.value) {\n          <button\n            mat-mini-fab\n            color=\"primary\"\n            class=\"ngx-mat-datatable-operator-button\"\n            (click)=\"control.setValue(operator); isOpen = !isOpen\">\n            {{ operator }}\n          </button>\n        }\n      }\n    </div>\n  </ng-template>\n}\n", styles: [".ngx-mat-datatable-operator-button{--mdc-fab-small-container-elevation-shadow: none;--mdc-fab-small-hover-container-elevation-shadow: none;--mdc-fab-small-focus-container-elevation-shadow: none;--mdc-fab-small-container-shape: 50%;--mdc-fab-small-container-color: var(--mat-sys-primary);--mat-fab-small-foreground-color: var(--mat-sys-on-primary);font-size:16px;width:26px;height:26px;padding:6px}.ngx-mat-datatable-operator-button ::ng-deep .mat-mdc-button-touch-target{height:36px;width:36px}.ngx-mat-datatable-operator-column{display:flex;box-sizing:border-box;flex-direction:column}.ngx-mat-datatable-operator-column .ngx-mat-datatable-operator-button{margin-top:8px}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "ngmodule", type: OverlayModule }, { kind: "directive", type: i1$2.CdkConnectedOverlay, selector: "[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]", inputs: ["cdkConnectedOverlayOrigin", "cdkConnectedOverlayPositions", "cdkConnectedOverlayPositionStrategy", "cdkConnectedOverlayOffsetX", "cdkConnectedOverlayOffsetY", "cdkConnectedOverlayWidth", "cdkConnectedOverlayHeight", "cdkConnectedOverlayMinWidth", "cdkConnectedOverlayMinHeight", "cdkConnectedOverlayBackdropClass", "cdkConnectedOverlayPanelClass", "cdkConnectedOverlayViewportMargin", "cdkConnectedOverlayScrollStrategy", "cdkConnectedOverlayOpen", "cdkConnectedOverlayDisableClose", "cdkConnectedOverlayTransformOriginOn", "cdkConnectedOverlayHasBackdrop", "cdkConnectedOverlayLockPosition", "cdkConnectedOverlayFlexibleDimensions", "cdkConnectedOverlayGrowAfterOpen", "cdkConnectedOverlayPush", "cdkConnectedOverlayDisposeOnNavigation"], outputs: ["backdropClick", "positionChange", "attach", "detach", "overlayKeydown", "overlayOutsideClick"], exportAs: ["cdkConnectedOverlay"] }, { kind: "directive", type: i1$2.CdkOverlayOrigin, selector: "[cdk-overlay-origin], [overlay-origin], [cdkOverlayOrigin]", exportAs: ["cdkOverlayOrigin"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatMiniFabButton, selector: "button[mat-mini-fab]", exportAs: ["matButton"] }], animations: [
            trigger('fade', [
                transition(':enter', [
                    style({ opacity: 0 }), // initial
                    animate('0.2s', style({ opacity: 1 })), // final
                ]),
                transition(':leave', [
                    style({ opacity: 1 }), // initial
                    animate('0.2s', style({ opacity: 0 })), // final
                ]),
            ]),
        ] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: OperatorSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-operator-select', imports: [CommonModule, OverlayModule, MatIconModule, MatButtonModule], animations: [
                        trigger('fade', [
                            transition(':enter', [
                                style({ opacity: 0 }), // initial
                                animate('0.2s', style({ opacity: 1 })), // final
                            ]),
                            transition(':leave', [
                                style({ opacity: 1 }), // initial
                                animate('0.2s', style({ opacity: 0 })), // final
                            ]),
                        ]),
                    ], providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: forwardRef(() => OperatorSelectComponent),
                        },
                    ], template: "<!-- @format -->\n\n@if (control) {\n  <button\n    mat-mini-fab\n    color=\"primary\"\n    class=\"ngx-mat-datatable-operator-button\"\n    cdkOverlayOrigin\n    #trigger=\"cdkOverlayOrigin\"\n    (click)=\"$event.stopPropagation(); isOpen = !isOpen\">\n    {{ control.value }}\n  </button>\n\n  <ng-template cdkConnectedOverlay [cdkConnectedOverlayOrigin]=\"trigger\" [cdkConnectedOverlayOpen]=\"isOpen\">\n    <div class=\"ngx-mat-datatable-operator-column\" @fade>\n      @for (operator of operators; track operator) {\n        @if (operator !== control.value) {\n          <button\n            mat-mini-fab\n            color=\"primary\"\n            class=\"ngx-mat-datatable-operator-button\"\n            (click)=\"control.setValue(operator); isOpen = !isOpen\">\n            {{ operator }}\n          </button>\n        }\n      }\n    </div>\n  </ng-template>\n}\n", styles: [".ngx-mat-datatable-operator-button{--mdc-fab-small-container-elevation-shadow: none;--mdc-fab-small-hover-container-elevation-shadow: none;--mdc-fab-small-focus-container-elevation-shadow: none;--mdc-fab-small-container-shape: 50%;--mdc-fab-small-container-color: var(--mat-sys-primary);--mat-fab-small-foreground-color: var(--mat-sys-on-primary);font-size:16px;width:26px;height:26px;padding:6px}.ngx-mat-datatable-operator-button ::ng-deep .mat-mdc-button-touch-target{height:36px;width:36px}.ngx-mat-datatable-operator-column{display:flex;box-sizing:border-box;flex-direction:column}.ngx-mat-datatable-operator-column .ngx-mat-datatable-operator-button{margin-top:8px}\n"] }]
        }], propDecorators: { setDisableRange: [{
                type: Input,
                args: ['disableRange']
            }] } });

/** @format */
class HeaderDateFilterComponent {
    column;
    control;
    selectControl = new FormControl(undefined);
    rangeGroup = new FormGroup({
        from: new FormControl(undefined, Validators.required),
        to: new FormControl(undefined, Validators.required),
    });
    operatorControl = new FormControl('=');
    onChange = () => { };
    onTouched = () => { };
    _adapter = inject(DateAdapter);
    _intl = inject(MatDatepickerIntl);
    _locale = signal(inject(MAT_DATE_LOCALE));
    injector = inject(Injector);
    changeDetectorRef = inject(ChangeDetectorRef);
    subsink = new Subscription();
    writeValue = (value) => {
        // if (value?.operator && this.operatorControl.value !== value.operator) this.operatorControl.setValue(value.operator);
        // if (['<>', '≤≥'].includes(this.operatorControl.value!)) {
        //   if (value?.value?.from !== this.rangeGroup.value.from && value?.value?.to !== this.rangeGroup.value.to) {
        //     this.rangeGroup.setValue({ from: value.value.from, to: value.value.to });
        //   }
        // } else if (value?.value !== this.selectControl.value) this.selectControl.setValue(value?.value);
    };
    registerOnChange(onChange) {
        this.onChange = onChange;
    }
    registerOnTouched(onTouched) {
        this.onTouched = onTouched;
    }
    ngOnInit() {
        if (this.column.locale) {
            this._locale.set(this.column.locale);
            this._adapter.setLocale(this._locale());
            this._intl.changes.next();
        }
    }
    async ngAfterViewInit() {
        const ngControl = this.injector.get(NgControl, null);
        if (!ngControl)
            throw new Error(`${this.constructor.name} missing control [column:${this.column.columnDef}]`);
        this.control = ngControl.control;
        this.subsink.add(this.selectControl.valueChanges.pipe(debounceTime(500)).subscribe(value => {
            if (this.control.invalid)
                return;
            else if (!value)
                this.control.setValue(undefined);
            else
                this.control.setValue(this.buildValue(this.operatorControl.value, value));
        }));
        this.subsink.add(this.rangeGroup.valueChanges.pipe(debounceTime(500)).subscribe(value => {
            if (this.rangeGroup.invalid)
                return;
            if (!value)
                this.control.setValue(undefined);
            else
                this.control.setValue(this.buildValue(this.operatorControl.value, value));
        }));
        this.subsink.add(this.operatorControl.valueChanges.subscribe((value) => {
            if (['<>', '≤≥'].includes(value)) {
                if (!this.rangeGroup.value || this.rangeGroup.invalid)
                    return;
                this.control.setValue(this.buildValue(value, this.rangeGroup.value));
            }
            else {
                if (!this.selectControl.value)
                    return;
                this.control.setValue(this.buildValue(value, this.selectControl.value));
            }
        }));
        this.changeDetectorRef.detectChanges();
    }
    ngOnDestroy() {
        this.subsink.unsubscribe();
    }
    buildValue(operator, value) {
        switch (operator) {
            case '=':
                return {
                    operator: '≤≥',
                    value: { from: moment(value).startOf('day'), to: moment(value).endOf('day') },
                };
            case '>':
                return { operator, value: moment(value).endOf('day') };
            case '≥':
                return { operator, value: moment(value).startOf('day') };
            case '<':
                return { operator, value: moment(value).startOf('day') };
            case '≤':
                return { operator, value: moment(value).endOf('day') };
            case '<>':
                return { operator, value: { from: moment(value.from).endOf('day'), to: moment(value.to).startOf('day') } };
            case '≤≥':
                return { operator, value: { from: moment(value.from).startOf('day'), to: moment(value.to).endOf('day') } };
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderDateFilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.4", type: HeaderDateFilterComponent, isStandalone: true, selector: "lib-header-date-filter", inputs: { column: "column" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: forwardRef(() => HeaderDateFilterComponent),
            },
            provideMomentDateAdapter(),
        ], ngImport: i0, template: "<!-- @format -->\n\n@if (selectControl) {\n  @if (['<>', '\u2264\u2265'].includes(operatorControl.value!)) {\n    <mat-form-field class=\"ngx-datatable-date-filter\" appearance=\"fill\" [class.has-value]=\"selectControl.value\">\n      <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n\n      <lib-operator-select matPrefix [formControl]=\"operatorControl\"></lib-operator-select>\n\n      <mat-date-range-input [formGroup]=\"rangeGroup\" [rangePicker]=\"rangePicker\">\n        <input matStartDate formControlName=\"from\" [placeholder]=\"column.placeholder!\" />\n        <input matEndDate formControlName=\"to\" [placeholder]=\"column.placeholder!\" />\n      </mat-date-range-input>\n      <mat-datepicker-toggle matIconSuffix [for]=\"rangePicker\"></mat-datepicker-toggle>\n      <mat-date-range-picker #rangePicker></mat-date-range-picker>\n\n      <button *ngIf=\"selectControl.value\" mat-icon-button matSuffix size=\"small\" (click)=\"rangeGroup.reset()\">\n        <mat-icon>close</mat-icon>\n      </button>\n    </mat-form-field>\n  } @else {\n    <mat-form-field class=\"ngx-datatable-date-filter\" appearance=\"fill\" [class.has-value]=\"selectControl.value\">\n      <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n\n      <lib-operator-select matPrefix [formControl]=\"operatorControl\"></lib-operator-select>\n\n      <input matInput [matDatepicker]=\"datePicker\" [formControl]=\"selectControl\" [placeholder]=\"column.placeholder!\" />\n      <mat-datepicker-toggle matIconSuffix [for]=\"datePicker\"></mat-datepicker-toggle>\n      <mat-datepicker #datePicker></mat-datepicker>\n\n      <button\n        *ngIf=\"selectControl.value\"\n        mat-icon-button\n        matSuffix\n        size=\"small\"\n        (click)=\"selectControl.setValue(undefined)\">\n        <mat-icon>close</mat-icon>\n      </button>\n    </mat-form-field>\n  }\n}\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}mat-form-field ::ng-deep .mat-mdc-form-field-icon-suffix{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatDatepickerModule }, { kind: "component", type: i4$2.MatDatepicker, selector: "mat-datepicker", exportAs: ["matDatepicker"] }, { kind: "directive", type: i4$2.MatDatepickerInput, selector: "input[matDatepicker]", inputs: ["matDatepicker", "min", "max", "matDatepickerFilter"], exportAs: ["matDatepickerInput"] }, { kind: "component", type: i4$2.MatDatepickerToggle, selector: "mat-datepicker-toggle", inputs: ["for", "tabIndex", "aria-label", "disabled", "disableRipple"], exportAs: ["matDatepickerToggle"] }, { kind: "component", type: i4$2.MatDateRangeInput, selector: "mat-date-range-input", inputs: ["rangePicker", "required", "dateFilter", "min", "max", "disabled", "separator", "comparisonStart", "comparisonEnd"], exportAs: ["matDateRangeInput"] }, { kind: "directive", type: i4$2.MatStartDate, selector: "input[matStartDate]", outputs: ["dateChange", "dateInput"] }, { kind: "directive", type: i4$2.MatEndDate, selector: "input[matEndDate]", outputs: ["dateChange", "dateInput"] }, { kind: "component", type: i4$2.MatDateRangePicker, selector: "mat-date-range-picker", exportAs: ["matDateRangePicker"] }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$1.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$1.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i4$1.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i5$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i6.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "component", type: OperatorSelectComponent, selector: "lib-operator-select", inputs: ["disableRange"] }, { kind: "pipe", type: SafeHtmlPipe, name: "safeHtml" }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderDateFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-header-date-filter', imports: [
                        CommonModule,
                        FormsModule,
                        MatButtonModule,
                        MatDatepickerModule,
                        MatFormFieldModule,
                        MatIconModule,
                        MatInputModule,
                        ReactiveFormsModule,
                        OperatorSelectComponent,
                        SafeHtmlPipe,
                    ], providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: forwardRef(() => HeaderDateFilterComponent),
                        },
                        provideMomentDateAdapter(),
                    ], changeDetection: ChangeDetectionStrategy.OnPush, template: "<!-- @format -->\n\n@if (selectControl) {\n  @if (['<>', '\u2264\u2265'].includes(operatorControl.value!)) {\n    <mat-form-field class=\"ngx-datatable-date-filter\" appearance=\"fill\" [class.has-value]=\"selectControl.value\">\n      <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n\n      <lib-operator-select matPrefix [formControl]=\"operatorControl\"></lib-operator-select>\n\n      <mat-date-range-input [formGroup]=\"rangeGroup\" [rangePicker]=\"rangePicker\">\n        <input matStartDate formControlName=\"from\" [placeholder]=\"column.placeholder!\" />\n        <input matEndDate formControlName=\"to\" [placeholder]=\"column.placeholder!\" />\n      </mat-date-range-input>\n      <mat-datepicker-toggle matIconSuffix [for]=\"rangePicker\"></mat-datepicker-toggle>\n      <mat-date-range-picker #rangePicker></mat-date-range-picker>\n\n      <button *ngIf=\"selectControl.value\" mat-icon-button matSuffix size=\"small\" (click)=\"rangeGroup.reset()\">\n        <mat-icon>close</mat-icon>\n      </button>\n    </mat-form-field>\n  } @else {\n    <mat-form-field class=\"ngx-datatable-date-filter\" appearance=\"fill\" [class.has-value]=\"selectControl.value\">\n      <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n\n      <lib-operator-select matPrefix [formControl]=\"operatorControl\"></lib-operator-select>\n\n      <input matInput [matDatepicker]=\"datePicker\" [formControl]=\"selectControl\" [placeholder]=\"column.placeholder!\" />\n      <mat-datepicker-toggle matIconSuffix [for]=\"datePicker\"></mat-datepicker-toggle>\n      <mat-datepicker #datePicker></mat-datepicker>\n\n      <button\n        *ngIf=\"selectControl.value\"\n        mat-icon-button\n        matSuffix\n        size=\"small\"\n        (click)=\"selectControl.setValue(undefined)\">\n        <mat-icon>close</mat-icon>\n      </button>\n    </mat-form-field>\n  }\n}\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}mat-form-field ::ng-deep .mat-mdc-form-field-icon-suffix{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row}\n"] }]
        }], propDecorators: { column: [{
                type: Input
            }] } });

/** @format */
const TIME_UNITS = ['second', 'minute', 'hour', 'day', 'month', 'year'];
const MOMENT_RELATIVE_TIME_KEY = ['ss', 'mm', 'hh', 'dd', 'MM', 'yy'];
class TimeUnitSelectComponent {
    static toMilliseconds(value, unit) {
        return moment.duration(value, unit).as('milliseconds');
    }
    static convert(value, from, to) {
        if (to === undefined)
            (to = from), (from = 'millisecond');
        return moment.duration(value, from).as(to);
    }
    set setLocale(locale) {
        this.locale = locale || moment.locale();
        this.loadUnitNames();
    }
    locale = moment.locale();
    units = TIME_UNITS;
    unitNames = {};
    isOpen = false;
    control;
    onChange = () => { };
    onTouched = () => { };
    injector = inject(Injector);
    changeDetectorRef = inject(ChangeDetectorRef);
    writeValue = () => { };
    registerOnChange(onChange) {
        this.onChange = onChange;
    }
    registerOnTouched(onTouched) {
        this.onTouched = onTouched;
    }
    ngOnInit() {
        this.loadUnitNames();
    }
    async ngAfterViewInit() {
        const ngControl = this.injector.get(NgControl, null);
        if (!ngControl)
            throw new Error(`${this.constructor.name} missing control`);
        this.control = ngControl.control;
        this.changeDetectorRef.detectChanges();
    }
    loadUnitNames() {
        this.unitNames = this.units.reduce((pv, cv, i) => ((pv[cv] = moment
            .localeData(this.locale)
            .relativeTime('', true, MOMENT_RELATIVE_TIME_KEY[i], false)
            .trim()),
            pv), {});
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: TimeUnitSelectComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.4", type: TimeUnitSelectComponent, isStandalone: true, selector: "lib-time-unit-select", inputs: { setLocale: ["locale", "setLocale"] }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: forwardRef(() => TimeUnitSelectComponent),
            },
        ], ngImport: i0, template: "<!-- @format -->\n\n@if (control) {\n  <button\n    mat-flat-button\n    color=\"primary\"\n    class=\"ngx-mat-datatable-time-unit-button\"\n    cdkOverlayOrigin\n    #trigger=\"cdkOverlayOrigin\"\n    (click)=\"$event.stopPropagation(); isOpen = !isOpen\">\n    <span>\n      {{ unitNames[control.value] }}\n    </span>\n  </button>\n\n  <ng-template cdkConnectedOverlay [cdkConnectedOverlayOrigin]=\"trigger\" [cdkConnectedOverlayOpen]=\"isOpen\">\n    <div class=\"ngx-mat-datatable-time-unit-column\" @fade>\n      @for (unit of units; track unit) {\n        @if (unit !== control.value) {\n          <button\n            mat-flat-button\n            color=\"primary\"\n            class=\"ngx-mat-datatable-time-unit-button\"\n            (click)=\"control.setValue(unit); isOpen = !isOpen\">\n            <span>\n              {{ unitNames[unit] }}\n            </span>\n          </button>\n        }\n      }\n    </div>\n  </ng-template>\n}\n", styles: [".ngx-mat-datatable-time-unit-button{font-size:12px;height:26px;padding:6px}.ngx-mat-datatable-time-unit-button ::ng-deep .mat-mdc-button-touch-target{height:36px;width:36px}.ngx-mat-datatable-time-unit-column{display:flex;box-sizing:border-box;flex-direction:column}.ngx-mat-datatable-time-unit-column .ngx-mat-datatable-time-unit-button{margin-top:8px}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "ngmodule", type: OverlayModule }, { kind: "directive", type: i1$2.CdkConnectedOverlay, selector: "[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]", inputs: ["cdkConnectedOverlayOrigin", "cdkConnectedOverlayPositions", "cdkConnectedOverlayPositionStrategy", "cdkConnectedOverlayOffsetX", "cdkConnectedOverlayOffsetY", "cdkConnectedOverlayWidth", "cdkConnectedOverlayHeight", "cdkConnectedOverlayMinWidth", "cdkConnectedOverlayMinHeight", "cdkConnectedOverlayBackdropClass", "cdkConnectedOverlayPanelClass", "cdkConnectedOverlayViewportMargin", "cdkConnectedOverlayScrollStrategy", "cdkConnectedOverlayOpen", "cdkConnectedOverlayDisableClose", "cdkConnectedOverlayTransformOriginOn", "cdkConnectedOverlayHasBackdrop", "cdkConnectedOverlayLockPosition", "cdkConnectedOverlayFlexibleDimensions", "cdkConnectedOverlayGrowAfterOpen", "cdkConnectedOverlayPush", "cdkConnectedOverlayDisposeOnNavigation"], outputs: ["backdropClick", "positionChange", "attach", "detach", "overlayKeydown", "overlayOutsideClick"], exportAs: ["cdkConnectedOverlay"] }, { kind: "directive", type: i1$2.CdkOverlayOrigin, selector: "[cdk-overlay-origin], [overlay-origin], [cdkOverlayOrigin]", exportAs: ["cdkOverlayOrigin"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }], animations: [
            trigger('fade', [
                transition(':enter', [
                    style({ opacity: 0 }), // initial
                    animate('0.2s', style({ opacity: 1 })), // final
                ]),
                transition(':leave', [
                    style({ opacity: 1 }), // initial
                    animate('0.2s', style({ opacity: 0 })), // final
                ]),
            ]),
        ] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: TimeUnitSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-time-unit-select', imports: [CommonModule, OverlayModule, MatIconModule, MatButtonModule], animations: [
                        trigger('fade', [
                            transition(':enter', [
                                style({ opacity: 0 }), // initial
                                animate('0.2s', style({ opacity: 1 })), // final
                            ]),
                            transition(':leave', [
                                style({ opacity: 1 }), // initial
                                animate('0.2s', style({ opacity: 0 })), // final
                            ]),
                        ]),
                    ], providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: forwardRef(() => TimeUnitSelectComponent),
                        },
                    ], template: "<!-- @format -->\n\n@if (control) {\n  <button\n    mat-flat-button\n    color=\"primary\"\n    class=\"ngx-mat-datatable-time-unit-button\"\n    cdkOverlayOrigin\n    #trigger=\"cdkOverlayOrigin\"\n    (click)=\"$event.stopPropagation(); isOpen = !isOpen\">\n    <span>\n      {{ unitNames[control.value] }}\n    </span>\n  </button>\n\n  <ng-template cdkConnectedOverlay [cdkConnectedOverlayOrigin]=\"trigger\" [cdkConnectedOverlayOpen]=\"isOpen\">\n    <div class=\"ngx-mat-datatable-time-unit-column\" @fade>\n      @for (unit of units; track unit) {\n        @if (unit !== control.value) {\n          <button\n            mat-flat-button\n            color=\"primary\"\n            class=\"ngx-mat-datatable-time-unit-button\"\n            (click)=\"control.setValue(unit); isOpen = !isOpen\">\n            <span>\n              {{ unitNames[unit] }}\n            </span>\n          </button>\n        }\n      }\n    </div>\n  </ng-template>\n}\n", styles: [".ngx-mat-datatable-time-unit-button{font-size:12px;height:26px;padding:6px}.ngx-mat-datatable-time-unit-button ::ng-deep .mat-mdc-button-touch-target{height:36px;width:36px}.ngx-mat-datatable-time-unit-column{display:flex;box-sizing:border-box;flex-direction:column}.ngx-mat-datatable-time-unit-column .ngx-mat-datatable-time-unit-button{margin-top:8px}\n"] }]
        }], propDecorators: { setLocale: [{
                type: Input,
                args: ['locale']
            }] } });

/** @format */
class HeaderDurationFilterComponent {
    column;
    control;
    selectControl = new FormControl(undefined);
    rangeGroup = new FormGroup({
        start: new FormControl(undefined, Validators.required),
        end: new FormControl(undefined, Validators.required),
    });
    operatorControl = new FormControl('=');
    timeUnitControl = new FormControl('second');
    onChange = () => { };
    onTouched = () => { };
    injector = inject(Injector);
    changeDetectorRef = inject(ChangeDetectorRef);
    subsink = new Subscription();
    writeValue = (value) => {
        if (value?.unitOfTime)
            this.timeUnitControl.setValue(value.unitOfTime, { emitEvent: false });
        if (value?.value !== null && value?.value !== undefined) {
            let selectValue = TimeUnitSelectComponent.convert(value.value, this.timeUnitControl.value);
            if (this.selectControl.value !== selectValue)
                this.selectControl.setValue(selectValue);
        }
        else
            this.selectControl.setValue(null);
    };
    registerOnChange(onChange) {
        this.onChange = onChange;
    }
    registerOnTouched(onTouched) {
        this.onTouched = onTouched;
    }
    ngOnInit() { }
    async ngAfterViewInit() {
        const ngControl = this.injector.get(NgControl, null);
        if (!ngControl)
            throw new Error(`${this.constructor.name} missing control [column:${this.column.columnDef}]`);
        this.control = ngControl.control;
        this.subsink.add(this.selectControl.valueChanges.pipe(debounceTime(500)).subscribe(value => {
            if (this.control.invalid)
                return;
            else if (!value)
                this.control.setValue(undefined);
            else
                this.control.setValue({
                    unitOfTimeValue: value,
                    value: TimeUnitSelectComponent.toMilliseconds(value, this.timeUnitControl.value),
                    regex: false,
                    operator: this.operatorControl.value,
                    unitOfTime: this.timeUnitControl.value,
                });
        }));
        this.subsink.add(this.operatorControl.valueChanges.subscribe((value) => {
            if (!this.selectControl.value)
                return;
            this.control.setValue({
                unitOfTimeValue: this.selectControl.value,
                value: TimeUnitSelectComponent.toMilliseconds(this.selectControl.value, this.timeUnitControl.value),
                regex: false,
                operator: value,
                unitOfTime: this.timeUnitControl.value,
            });
        }));
        this.subsink.add(this.timeUnitControl.valueChanges.subscribe((value) => {
            if (!this.selectControl.value)
                return;
            this.control.setValue({
                unitOfTimeValue: TimeUnitSelectComponent.convert(this.selectControl.value, this.control.value.unitOfTime, value),
                value: TimeUnitSelectComponent.toMilliseconds(this.selectControl.value, this.control.value.unitOfTime),
                regex: false,
                operator: this.operatorControl.value,
                unitOfTime: value,
            });
        }));
        this.changeDetectorRef.detectChanges();
    }
    ngOnDestroy() {
        this.subsink.unsubscribe();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderDurationFilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.4", type: HeaderDurationFilterComponent, isStandalone: true, selector: "lib-header-duration-filter", inputs: { column: "column" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: forwardRef(() => HeaderDurationFilterComponent),
            },
        ], ngImport: i0, template: "<!-- @format -->\n\n@if (selectControl) {\n  <mat-form-field class=\"ngx-datatable-duration-filter\" appearance=\"fill\" [class.has-value]=\"selectControl.value\">\n    <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n\n    <lib-operator-select disableRange matPrefix [formControl]=\"operatorControl\"></lib-operator-select>\n\n    <input matInput type=\"number\" [formControl]=\"selectControl\" [placeholder]=\"column.placeholder!\" />\n\n    <lib-time-unit-select [locale]=\"column.locale\" matSuffix [formControl]=\"timeUnitControl\"></lib-time-unit-select>\n\n    <button\n      *ngIf=\"selectControl.value\"\n      mat-icon-button\n      matSuffix\n      size=\"small\"\n      (click)=\"selectControl.setValue(undefined)\">\n      <mat-icon>close</mat-icon>\n    </button>\n  </mat-form-field>\n}\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}mat-form-field ::ng-deep .mat-mdc-form-field-icon-suffix{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$1.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$1.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i4$1.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i5$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i6.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: OperatorSelectComponent, selector: "lib-operator-select", inputs: ["disableRange"] }, { kind: "component", type: TimeUnitSelectComponent, selector: "lib-time-unit-select", inputs: ["locale"] }, { kind: "pipe", type: SafeHtmlPipe, name: "safeHtml" }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderDurationFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-header-duration-filter', imports: [
                        CommonModule,
                        FormsModule,
                        MatButtonModule,
                        MatFormFieldModule,
                        MatIconModule,
                        MatInputModule,
                        ReactiveFormsModule,
                        OperatorSelectComponent,
                        TimeUnitSelectComponent,
                        SafeHtmlPipe,
                    ], providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: forwardRef(() => HeaderDurationFilterComponent),
                        },
                    ], template: "<!-- @format -->\n\n@if (selectControl) {\n  <mat-form-field class=\"ngx-datatable-duration-filter\" appearance=\"fill\" [class.has-value]=\"selectControl.value\">\n    <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n\n    <lib-operator-select disableRange matPrefix [formControl]=\"operatorControl\"></lib-operator-select>\n\n    <input matInput type=\"number\" [formControl]=\"selectControl\" [placeholder]=\"column.placeholder!\" />\n\n    <lib-time-unit-select [locale]=\"column.locale\" matSuffix [formControl]=\"timeUnitControl\"></lib-time-unit-select>\n\n    <button\n      *ngIf=\"selectControl.value\"\n      mat-icon-button\n      matSuffix\n      size=\"small\"\n      (click)=\"selectControl.setValue(undefined)\">\n      <mat-icon>close</mat-icon>\n    </button>\n  </mat-form-field>\n}\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}mat-form-field ::ng-deep .mat-mdc-form-field-icon-suffix{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row}\n"] }]
        }], propDecorators: { column: [{
                type: Input
            }] } });

/** @format */
class HeaderNumberFilterComponent {
    column;
    control;
    selectControl = new FormControl();
    operatorControl = new FormControl('=');
    onChange = () => { };
    onTouched = () => { };
    injector = inject(Injector);
    changeDetectorRef = inject(ChangeDetectorRef);
    subsink = new Subscription();
    writeValue = (value) => {
        if (value?.value !== this.selectControl.value)
            this.selectControl.setValue(value?.value);
    };
    registerOnChange(onChange) {
        this.onChange = onChange;
    }
    registerOnTouched(onTouched) {
        this.onTouched = onTouched;
    }
    async ngAfterViewInit() {
        const ngControl = this.injector.get(NgControl, null);
        if (!ngControl)
            throw new Error(`${this.constructor.name} missing control [column:${this.column.columnDef}]`);
        this.control = ngControl.control;
        this.subsink.add(this.selectControl.valueChanges.subscribe((value) => {
            if (this.control.invalid)
                return;
            else if (!value)
                this.control.setValue(undefined);
            else
                this.control.setValue({ value, regex: false, operator: this.operatorControl.value });
        }));
        this.subsink.add(this.operatorControl.valueChanges.subscribe((value) => {
            if (this.control.value === null || this.control.value === undefined)
                return;
            this.control.setValue({ value: this.selectControl.value, regex: false, operator: value });
        }));
        this.changeDetectorRef.detectChanges();
    }
    ngOnDestroy() {
        this.subsink.unsubscribe();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderNumberFilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.4", type: HeaderNumberFilterComponent, isStandalone: true, selector: "lib-header-number-filter", inputs: { column: "column" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: forwardRef(() => HeaderNumberFilterComponent),
            },
        ], ngImport: i0, template: "<!-- @format -->\n\n@if (selectControl) {\n  <mat-form-field class=\"ngx-datatable-number-filter\" appearance=\"fill\" [class.has-value]=\"selectControl.value\">\n    <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n\n    <lib-operator-select disableRange matPrefix [formControl]=\"operatorControl\"></lib-operator-select>\n\n    <input matInput [formControl]=\"selectControl\" type=\"number\" />\n\n    <button\n      *ngIf=\"selectControl.value\"\n      mat-icon-button\n      matSuffix\n      size=\"small\"\n      (click)=\"selectControl.setValue(undefined)\">\n      <mat-icon>close</mat-icon>\n    </button>\n  </mat-form-field>\n}\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$1.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$1.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i4$1.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i5$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i6.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "ngmodule", type: MatMenuModule }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: OperatorSelectComponent, selector: "lib-operator-select", inputs: ["disableRange"] }, { kind: "pipe", type: SafeHtmlPipe, name: "safeHtml" }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderNumberFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-header-number-filter', imports: [
                        CommonModule,
                        FormsModule,
                        MatButtonModule,
                        MatFormFieldModule,
                        MatIconModule,
                        MatInputModule,
                        MatMenuModule,
                        ReactiveFormsModule,
                        OperatorSelectComponent,
                        SafeHtmlPipe,
                    ], providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: forwardRef(() => HeaderNumberFilterComponent),
                        },
                    ], template: "<!-- @format -->\n\n@if (selectControl) {\n  <mat-form-field class=\"ngx-datatable-number-filter\" appearance=\"fill\" [class.has-value]=\"selectControl.value\">\n    <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n\n    <lib-operator-select disableRange matPrefix [formControl]=\"operatorControl\"></lib-operator-select>\n\n    <input matInput [formControl]=\"selectControl\" type=\"number\" />\n\n    <button\n      *ngIf=\"selectControl.value\"\n      mat-icon-button\n      matSuffix\n      size=\"small\"\n      (click)=\"selectControl.setValue(undefined)\">\n      <mat-icon>close</mat-icon>\n    </button>\n  </mat-form-field>\n}\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}\n"] }]
        }], propDecorators: { column: [{
                type: Input
            }] } });

/** @format */
class SelectOptionPipe {
    transform(value, options) {
        if (!options)
            return null;
        return options.find((option) => option.value === value) || null;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: SelectOptionPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.0.4", ngImport: i0, type: SelectOptionPipe, isStandalone: true, name: "selectOption" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: SelectOptionPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'selectOption' }]
        }] });

/** @format */
class HeaderSelectFilterComponent {
    column;
    control;
    selectControl = new FormControl();
    onChange = () => { };
    onTouched = () => { };
    injector = inject(Injector);
    changeDetectorRef = inject(ChangeDetectorRef);
    subsink = new Subscription();
    writeValue = (value) => {
        if (value?.value !== this.selectControl.value)
            this.selectControl.setValue(value?.value);
    };
    registerOnChange(onChange) {
        this.onChange = onChange;
    }
    registerOnTouched(onTouched) {
        this.onTouched = onTouched;
    }
    async ngAfterViewInit() {
        const ngControl = this.injector.get(NgControl, null);
        if (!ngControl)
            throw new Error(`${this.constructor.name} missing control [column:${this.column.columnDef}]`);
        this.control = ngControl.control;
        this.subsink.add(this.selectControl.valueChanges.subscribe((value) => {
            if (value === undefined)
                this.control.setValue(undefined);
            else
                this.control.setValue({ value, regex: false });
        }));
        this.changeDetectorRef.detectChanges();
    }
    ngOnDestroy() {
        this.subsink.unsubscribe();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderSelectFilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.4", type: HeaderSelectFilterComponent, isStandalone: true, selector: "lib-header-select-filter", inputs: { column: "column" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: forwardRef(() => HeaderSelectFilterComponent),
            },
        ], ngImport: i0, template: "<!-- @format -->\n\n@if (selectControl) {\n  <mat-form-field appearance=\"fill\">\n    <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n    <mat-select [formControl]=\"selectControl\" [placeholder]=\"column.placeholder!\">\n      @let options = column.options | async;\n\n      <mat-select-trigger>\n        @let option = selectControl.value | selectOption: options;\n        @if (option) {\n          <ng-container *ngTemplateOutlet=\"selectOption; context: { option }\"></ng-container>\n        } @else {\n          <mat-label [innerHTML]=\"selectControl.value | safeHtml\"></mat-label>\n        }\n      </mat-select-trigger>\n      @for (option of options; track option) {\n        <mat-option [value]=\"option.value\">\n          <ng-container *ngTemplateOutlet=\"selectOption; context: { option }\"></ng-container>\n        </mat-option>\n      }\n    </mat-select>\n\n    <button\n      *ngIf=\"selectControl.value\"\n      mat-icon-button\n      matSuffix\n      size=\"small\"\n      (click)=\"selectControl.setValue(undefined)\">\n      <mat-icon>close</mat-icon>\n    </button>\n  </mat-form-field>\n}\n\n<ng-template #selectOption let-option=\"option\">\n  <div class=\"option\">\n    @if (option.icon) {\n      @switch (option.iconSrc) {\n        @case ('svg') {\n          <mat-icon [svgIcon]=\"option.icon\" [style.color]=\"option.iconColor\" [style.margin-right.px]=\"8\"></mat-icon>\n        }\n        @default {\n          <mat-icon [style.color]=\"option.iconColor\" [style.margin-right.px]=\"8\">\n            {{ option.icon }}\n          </mat-icon>\n        }\n      }\n    }\n    <mat-label [style.color]=\"option.color\" [innerHTML]=\"option.name | safeHtml\"></mat-label>\n  </div>\n</ng-template>\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}.option{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "pipe", type: i1$1.AsyncPipe, name: "async" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$1.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$1.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i5$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatSelectModule }, { kind: "component", type: i6$1.MatSelect, selector: "mat-select", inputs: ["aria-describedby", "panelClass", "disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator", "placeholder", "required", "multiple", "disableOptionCentering", "compareWith", "value", "aria-label", "aria-labelledby", "errorStateMatcher", "typeaheadDebounceInterval", "sortComparator", "id", "panelWidth", "canSelectNullableOptions"], outputs: ["openedChange", "opened", "closed", "selectionChange", "valueChange"], exportAs: ["matSelect"] }, { kind: "directive", type: i6$1.MatSelectTrigger, selector: "mat-select-trigger" }, { kind: "component", type: i5.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "pipe", type: SelectOptionPipe, name: "selectOption" }, { kind: "pipe", type: SafeHtmlPipe, name: "safeHtml" }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderSelectFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-header-select-filter', imports: [
                        CommonModule,
                        FormsModule,
                        MatButtonModule,
                        MatFormFieldModule,
                        MatIconModule,
                        MatSelectModule,
                        ReactiveFormsModule,
                        SelectOptionPipe,
                        SafeHtmlPipe,
                    ], providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: forwardRef(() => HeaderSelectFilterComponent),
                        },
                    ], template: "<!-- @format -->\n\n@if (selectControl) {\n  <mat-form-field appearance=\"fill\">\n    <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n    <mat-select [formControl]=\"selectControl\" [placeholder]=\"column.placeholder!\">\n      @let options = column.options | async;\n\n      <mat-select-trigger>\n        @let option = selectControl.value | selectOption: options;\n        @if (option) {\n          <ng-container *ngTemplateOutlet=\"selectOption; context: { option }\"></ng-container>\n        } @else {\n          <mat-label [innerHTML]=\"selectControl.value | safeHtml\"></mat-label>\n        }\n      </mat-select-trigger>\n      @for (option of options; track option) {\n        <mat-option [value]=\"option.value\">\n          <ng-container *ngTemplateOutlet=\"selectOption; context: { option }\"></ng-container>\n        </mat-option>\n      }\n    </mat-select>\n\n    <button\n      *ngIf=\"selectControl.value\"\n      mat-icon-button\n      matSuffix\n      size=\"small\"\n      (click)=\"selectControl.setValue(undefined)\">\n      <mat-icon>close</mat-icon>\n    </button>\n  </mat-form-field>\n}\n\n<ng-template #selectOption let-option=\"option\">\n  <div class=\"option\">\n    @if (option.icon) {\n      @switch (option.iconSrc) {\n        @case ('svg') {\n          <mat-icon [svgIcon]=\"option.icon\" [style.color]=\"option.iconColor\" [style.margin-right.px]=\"8\"></mat-icon>\n        }\n        @default {\n          <mat-icon [style.color]=\"option.iconColor\" [style.margin-right.px]=\"8\">\n            {{ option.icon }}\n          </mat-icon>\n        }\n      }\n    }\n    <mat-label [style.color]=\"option.color\" [innerHTML]=\"option.name | safeHtml\"></mat-label>\n  </div>\n</ng-template>\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}.option{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row}\n"] }]
        }], propDecorators: { column: [{
                type: Input
            }] } });

/** @format */
class HeaderTextFilterComponent {
    column;
    control;
    selectControl = new FormControl();
    onChange = () => { };
    onTouched = () => { };
    injector = inject(Injector);
    changeDetectorRef = inject(ChangeDetectorRef);
    subsink = new Subscription();
    writeValue = (value) => {
        if (value?.value !== this.selectControl.value)
            this.selectControl.setValue(value?.value);
    };
    registerOnChange(onChange) {
        this.onChange = onChange;
    }
    registerOnTouched(onTouched) {
        this.onTouched = onTouched;
    }
    async ngAfterViewInit() {
        const ngControl = this.injector.get(NgControl, null);
        if (!ngControl)
            throw new Error(`${this.constructor.name} missing control [column:${this.column.columnDef}]`);
        this.control = ngControl.control;
        this.subsink.add(this.selectControl.valueChanges.subscribe((value) => {
            if (!value)
                this.control.setValue(undefined);
            else
                this.control.setValue({ value, regex: true });
        }));
        this.changeDetectorRef.detectChanges();
    }
    ngOnDestroy() {
        this.subsink.unsubscribe();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderTextFilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.4", type: HeaderTextFilterComponent, isStandalone: true, selector: "lib-header-text-filter", inputs: { column: "column" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: forwardRef(() => HeaderTextFilterComponent),
            },
        ], ngImport: i0, template: "<!-- @format -->\n\n@if (selectControl) {\n  <mat-form-field appearance=\"fill\" [class.has-value]=\"selectControl.value\">\n    <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n    <input matInput [formControl]=\"selectControl\" />\n    <button\n      *ngIf=\"selectControl.value\"\n      mat-icon-button\n      matSuffix\n      size=\"small\"\n      (click)=\"selectControl.setValue(undefined)\">\n      <mat-icon>close</mat-icon>\n    </button>\n  </mat-form-field>\n}\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$1.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$1.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i5$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i6.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "pipe", type: SafeHtmlPipe, name: "safeHtml" }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: HeaderTextFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-header-text-filter', imports: [
                        CommonModule,
                        FormsModule,
                        MatButtonModule,
                        MatFormFieldModule,
                        MatIconModule,
                        MatInputModule,
                        ReactiveFormsModule,
                        SafeHtmlPipe,
                    ], providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: forwardRef(() => HeaderTextFilterComponent),
                        },
                    ], template: "<!-- @format -->\n\n@if (selectControl) {\n  <mat-form-field appearance=\"fill\" [class.has-value]=\"selectControl.value\">\n    <mat-label [innerHTML]=\"column.header | safeHtml\"></mat-label>\n    <input matInput [formControl]=\"selectControl\" />\n    <button\n      *ngIf=\"selectControl.value\"\n      mat-icon-button\n      matSuffix\n      size=\"small\"\n      (click)=\"selectControl.setValue(undefined)\">\n      <mat-icon>close</mat-icon>\n    </button>\n  </mat-form-field>\n}\n", styles: [":host{display:flex;flex:1 1 100%}mat-form-field{min-width:auto;flex:1 1 100%;margin:6px 0;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}\n"] }]
        }], propDecorators: { column: [{
                type: Input
            }] } });

/** @format */
const DEFAULT_LABELS = {
    noDateLabel: 'No data',
    itemsPerPageLabel: `Items per page:`,
    nextPageLabel: `Next page`,
    lastPageLabel: `Last page`,
    previousPageLabel: `Previous page`,
    firstPageLabel: `First page`,
    onLabel: `on`,
};
const LABELS = {
    fr: {
        noDateLabel: 'Aucune donnée',
        itemsPerPageLabel: `Éléments par page :`,
        nextPageLabel: `Page suivante`,
        lastPageLabel: `Dernière page`,
        previousPageLabel: `Page précédente`,
        firstPageLabel: `Première page`,
        onLabel: `sur`,
    },
};
const DEFAULT_NUMBER_OPTIONS = {
    separator: ',',
    decimal: '.',
};
const NUMBER_OPTIONS = {
    fr: {
        separator: ' ',
        decimal: ',',
    },
};
class NgxMatDatatableIntl {
    locale = inject(LOCALE_ID);
    noDateLabel;
    itemsPerPageLabel;
    nextPageLabel;
    lastPageLabel;
    previousPageLabel;
    firstPageLabel;
    onLabel;
    numberOptions;
    getRangeLabel = (page, pageSize, length) => {
        if (length === 0 || pageSize === 0)
            return `0 ${this.onLabel} ${length}`;
        length = Math.max(length, 0);
        const startIndex = page * pageSize;
        const endIndex = startIndex < length ? Math.min(startIndex + pageSize, length) : startIndex + pageSize;
        return `${startIndex + 1} - ${endIndex} ${this.onLabel} ${length}`;
    };
    constructor() {
        this.setLabels(LABELS[this.locale] ?? DEFAULT_LABELS);
        this.numberOptions = NUMBER_OPTIONS[this.locale] ?? DEFAULT_NUMBER_OPTIONS;
    }
    setLabels(labels) {
        this.noDateLabel = labels.noDateLabel;
        this.itemsPerPageLabel = labels.itemsPerPageLabel;
        this.nextPageLabel = labels.nextPageLabel;
        this.lastPageLabel = labels.lastPageLabel;
        this.previousPageLabel = labels.previousPageLabel;
        this.firstPageLabel = labels.firstPageLabel;
        this.onLabel = labels.onLabel;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatableIntl, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatableIntl });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatableIntl, decorators: [{
            type: Injectable
        }], ctorParameters: () => [] });

/** @format */
class MergePipe {
    transform(obj, src) {
        return src ? { ...obj, ...src } : { ...obj };
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: MergePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.0.4", ngImport: i0, type: MergePipe, isStandalone: true, name: "merge" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: MergePipe, decorators: [{
            type: Pipe,
            args: [{ name: 'merge' }]
        }] });

/** @format */
class ProgressSpinnerComponent {
    datatableIntl = inject(NgxMatDatatableIntl);
    diameter = 100;
    set setValue(value) {
        if (typeof value === 'string')
            this._value = parseFloat(value);
        else
            this._value = value;
        if (this.animateInView)
            this.load(this.isInView);
    }
    _value = 0;
    value = 0;
    color;
    set setDisplayValue(displayValue) {
        this.displayValue = displayValue !== false;
    }
    displayValue = true;
    get getColor() {
        return this.color;
    }
    fontSize = `${this.diameter / 5}px`;
    set setAnimateInView(animateInView) {
        this.animateInView = animateInView !== false;
    }
    animateInView = true;
    set setDelay(delay) {
        if (typeof delay === 'string')
            this.delay = parseInt(delay);
        else
            this.delay = delay;
    }
    delay;
    isInView = false;
    load(intersect) {
        this.isInView = intersect;
        if (this.isInView) {
            if (this.delay)
                setTimeout(() => (this.value = this._value), this.delay);
            else
                this.value = this._value;
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: ProgressSpinnerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.0.4", type: ProgressSpinnerComponent, isStandalone: true, selector: "lib-progress-spinner", inputs: { diameter: "diameter", setValue: ["value", "setValue"], color: "color", setDisplayValue: ["displayValue", "setDisplayValue"], fontSize: "fontSize", setAnimateInView: ["animateInView", "setAnimateInView"], setDelay: ["delay", "setDelay"] }, host: { properties: { "style.--progress-spinner-color": "this.getColor" } }, ngImport: i0, template: "<!-- @format -->\n\n<div id=\"container\" [style.font-size]=\"fontSize\" [style.width.px]=\"diameter\" [style.height.px]=\"diameter\">\n  <mat-progress-spinner id=\"background\" [diameter]=\"diameter\" mode=\"determinate\" [value]=\"100\"> </mat-progress-spinner>\n  <mat-progress-spinner\n    id=\"foreground\"\n    [diameter]=\"diameter\"\n    mode=\"determinate\"\n    [value]=\"value\"\n    intersectionObserver\n    (intersection)=\"load($event.intersect)\">\n  </mat-progress-spinner>\n  <div id=\"inner-block\">\n    <mat-label\n      [countUp]=\"value\"\n      [options]=\"datatableIntl.numberOptions | merge: { suffix: '%', duration: 0.6 }\"\n      [reanimateOnClick]=\"false\"></mat-label>\n    <ng-content></ng-content>\n  </div>\n</div>\n", styles: ["#container{position:relative}#container #foreground{--mdc-circular-progress-active-indicator-color: var(--progress-spinner-color, varvar(--mat-sys-primary))}#container #foreground ::ng-deep .mdc-circular-progress__determinate-circle{stroke-width:var(--progress-spinner-stroke-width, 5%)!important}#container #background{position:absolute;left:50%;top:50%;transform:translate(-50%,-50%);--mdc-circular-progress-active-indicator-color: var(--progress-spinner-color, var(--mat-sys-primary))}#container #background ::ng-deep .mdc-circular-progress__determinate-circle{stroke-width:var(--progress-spinner-stroke-width, calc(5% + 2px) )!important;stroke-opacity:var(--progress-spinner-background-opacity, .2)}#container #inner-block{position:absolute;inset:0;box-sizing:content-box;display:flex;flex-direction:column;place-content:center center;align-items:center;overflow:hidden;border-radius:50%;margin:calc(var(--progress-spinner-stroke-width, calc(5% + 2px) ) + 2px);line-height:1em}#container:hover #foreground ::ng-deep .mdc-circular-progress__determinate-circle{stroke-width:var(--progress-spinner-stroke-width, calc(5% + 2px) )!important}#container:hover #background ::ng-deep .mdc-circular-progress__determinate-circle{stroke-opacity:var(--progress-spinner-background-opacity, .33)}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "ngmodule", type: MatProgressSpinnerModule }, { kind: "component", type: i1$3.MatProgressSpinner, selector: "mat-progress-spinner, mat-spinner", inputs: ["color", "mode", "value", "diameter", "strokeWidth"], exportAs: ["matProgressSpinner"] }, { kind: "ngmodule", type: IntersectionObserverModule }, { kind: "directive", type: i3.IntersectionObserverDirective, selector: "[intersectionObserver]", inputs: ["visitClass", "leaveClass", "removeVisitClass", "removeLeaveClass", "useScroll", "threshold", "autoRemove"], outputs: ["intersection"] }, { kind: "ngmodule", type: CountUpModule }, { kind: "directive", type: i3$3.CountUpDirective, selector: "[countUp]", inputs: ["countUp", "options", "reanimateOnClick"], outputs: ["complete"] }, { kind: "pipe", type: MergePipe, name: "merge" }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: ProgressSpinnerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-progress-spinner', imports: [CommonModule, MatProgressSpinnerModule, IntersectionObserverModule, CountUpModule, MergePipe], template: "<!-- @format -->\n\n<div id=\"container\" [style.font-size]=\"fontSize\" [style.width.px]=\"diameter\" [style.height.px]=\"diameter\">\n  <mat-progress-spinner id=\"background\" [diameter]=\"diameter\" mode=\"determinate\" [value]=\"100\"> </mat-progress-spinner>\n  <mat-progress-spinner\n    id=\"foreground\"\n    [diameter]=\"diameter\"\n    mode=\"determinate\"\n    [value]=\"value\"\n    intersectionObserver\n    (intersection)=\"load($event.intersect)\">\n  </mat-progress-spinner>\n  <div id=\"inner-block\">\n    <mat-label\n      [countUp]=\"value\"\n      [options]=\"datatableIntl.numberOptions | merge: { suffix: '%', duration: 0.6 }\"\n      [reanimateOnClick]=\"false\"></mat-label>\n    <ng-content></ng-content>\n  </div>\n</div>\n", styles: ["#container{position:relative}#container #foreground{--mdc-circular-progress-active-indicator-color: var(--progress-spinner-color, varvar(--mat-sys-primary))}#container #foreground ::ng-deep .mdc-circular-progress__determinate-circle{stroke-width:var(--progress-spinner-stroke-width, 5%)!important}#container #background{position:absolute;left:50%;top:50%;transform:translate(-50%,-50%);--mdc-circular-progress-active-indicator-color: var(--progress-spinner-color, var(--mat-sys-primary))}#container #background ::ng-deep .mdc-circular-progress__determinate-circle{stroke-width:var(--progress-spinner-stroke-width, calc(5% + 2px) )!important;stroke-opacity:var(--progress-spinner-background-opacity, .2)}#container #inner-block{position:absolute;inset:0;box-sizing:content-box;display:flex;flex-direction:column;place-content:center center;align-items:center;overflow:hidden;border-radius:50%;margin:calc(var(--progress-spinner-stroke-width, calc(5% + 2px) ) + 2px);line-height:1em}#container:hover #foreground ::ng-deep .mdc-circular-progress__determinate-circle{stroke-width:var(--progress-spinner-stroke-width, calc(5% + 2px) )!important}#container:hover #background ::ng-deep .mdc-circular-progress__determinate-circle{stroke-opacity:var(--progress-spinner-background-opacity, .33)}\n"] }]
        }], propDecorators: { diameter: [{
                type: Input
            }], setValue: [{
                type: Input,
                args: ['value']
            }], color: [{
                type: Input
            }], setDisplayValue: [{
                type: Input,
                args: ['displayValue']
            }], getColor: [{
                type: HostBinding,
                args: ['style.--progress-spinner-color']
            }], fontSize: [{
                type: Input
            }], setAnimateInView: [{
                type: Input,
                args: ['animateInView']
            }], setDelay: [{
                type: Input,
                args: ['delay']
            }] } });

/** @format */
class DatagridDataSource extends DataSource {
    service;
    loading$ = new BehaviorSubject(true);
    recordsFiltered = 0;
    recordsTotal;
    facets;
    rowSize = 0; // row size in kb
    options;
    dataStream = new BehaviorSubject([]);
    constructor(service) {
        super();
        this.service = service;
    }
    connect() {
        return this.dataStream;
    }
    disconnect() { }
    async loadData(options) {
        this.options = options;
        this.loading$.next(true);
        try {
            const result = await this.service(options);
            if (options.draw !== result.draw)
                return;
            this.recordsTotal = result.recordsTotal;
            this.recordsFiltered = result.recordsFiltered;
            this.facets = result.facets;
            this.dataStream.next(result.data);
            this.calculateRowSize(result.data);
        }
        finally {
            this.loading$.next(false);
        }
    }
    refresh() {
        if (this.options)
            this.loadData(this.options);
    }
    redraw(match) {
        const data = [];
        this.dataStream.value.forEach(d => {
            if (match) {
                if (match(d))
                    data.push({ ...d });
                else
                    data.push(d);
            }
            else
                data.push({ ...d });
        });
        this.dataStream.next(data);
    }
    calculateRowSize(data) {
        let total = 0;
        for (let row of data) {
            const size = new TextEncoder().encode(JSON.stringify(row)).length;
            const kiloBytes = size / 1024;
            total += kiloBytes / 1024;
        }
        this.rowSize = total && data.length ? total / data.length : 0;
    }
}

/** @format */
class NgxMatDatatableContentDirective {
    templateRef;
    id;
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatableContentDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
    static ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.4", type: NgxMatDatatableContentDirective, isStandalone: true, selector: "[ngxMatDatatableContent]", inputs: { id: ["ngxMatDatatableContent", "id"] }, ngImport: i0 });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatableContentDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngxMatDatatableContent]',
                }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }], propDecorators: { id: [{
                type: Input,
                args: ['ngxMatDatatableContent']
            }] } });

/** @format */
class BackgroundColorPipe {
    transform(row, column, options) {
        if (typeof column.backgroundColor === 'string')
            return column.backgroundColor;
        if (typeof column.backgroundColor === 'function')
            return column.backgroundColor(row);
        if (typeof options.rowBackgroundColor === 'string')
            return options.rowBackgroundColor;
        if (typeof options.rowBackgroundColor === 'function')
            return options.rowBackgroundColor(column, row);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: BackgroundColorPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.0.4", ngImport: i0, type: BackgroundColorPipe, isStandalone: true, name: "backgroundColor" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: BackgroundColorPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'backgroundColor' }]
        }] });

/** @format */
class ColorPipe {
    transform(row, column, options) {
        if (typeof column.color === 'string')
            return column.color;
        if (typeof column.color === 'function')
            return column.color(row);
        if (typeof options.rowColor === 'string')
            return options.rowColor;
        if (typeof options.rowColor === 'function')
            return options.rowColor(column, row);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: ColorPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.0.4", ngImport: i0, type: ColorPipe, isStandalone: true, name: "color" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: ColorPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'color' }]
        }] });

/** @format */
class FilterPipe {
    transform(obj, filter) {
        return (obj ?? []).filter(o => {
            for (let key of Object.keys(filter)) {
                if (o[key] !== filter[key])
                    return false;
            }
            return true;
        });
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: FilterPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.0.4", ngImport: i0, type: FilterPipe, isStandalone: true, name: "filter" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: FilterPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'filter' }]
        }] });

/** @format */
class FindContentPipe {
    transform(contentRefs, id) {
        return contentRefs?.find(ref => ref.id === id);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: FindContentPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.0.4", ngImport: i0, type: FindContentPipe, isStandalone: true, name: "findContent" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: FindContentPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'findContent' }]
        }] });

/** @format */
class FindPipe {
    transform(obj, filter) {
        return (obj ?? []).find(o => {
            for (let key of Object.keys(filter)) {
                if (o[key] !== filter[key])
                    return false;
            }
            return true;
        });
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: FindPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.0.4", ngImport: i0, type: FindPipe, isStandalone: true, name: "find" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: FindPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'find' }]
        }] });

/** @format */
class SortFacetEntriesPipe {
    transform(entries, options) {
        if (!options.options)
            return entries;
        return entries.sort((e1, e2) => {
            const ie1 = options.options.findIndex(o => o._id === e1._id);
            if (ie1 === -1)
                return 1;
            const ie2 = options.options.findIndex(o => o._id === e2._id);
            if (ie2 === -1)
                return -1;
            return ie1 - ie2;
        });
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: SortFacetEntriesPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.0.4", ngImport: i0, type: SortFacetEntriesPipe, isStandalone: true, name: "sortFacetEntries" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: SortFacetEntriesPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'sortFacetEntries' }]
        }] });

/** @format */
class SumPipe {
    transform(obj, by) {
        if (!obj || !obj.length)
            return 0;
        if (by)
            return obj.reduce((pv, cv) => (pv += cv[by]), 0);
        return obj.reduce((pv, cv) => (pv += cv), 0);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: SumPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.0.4", ngImport: i0, type: SumPipe, isStandalone: true, name: "sum" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: SumPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'sum' }]
        }] });

/** @format */
function duration(data, options) {
    const durationOption = { maxDecimalPoints: 0, largest: 1, fallbacks: ['en'] };
    if (options?.locale)
        durationOption.language = options.locale;
    if (options?.largest)
        durationOption.largest = options.largest;
    let value;
    if (typeof data === 'number')
        value = data;
    else if (typeof data === 'string') {
        const date = new Date(data);
        if (isNaN(date.valueOf()))
            return null;
        value = Date.now() - date.valueOf();
    }
    else if (typeof data?.valueOf === 'function')
        value = Date.now() - data.valueOf();
    if (!value)
        return null;
    return humanizeDuration(value, durationOption);
}

/** @format */
function get(obj, path) {
    const chunks = path.split('.');
    let value = obj;
    for (let i = 0; i < chunks.length; ++i) {
        value = value[chunks[i]];
        if (value === undefined || value === null)
            return null;
    }
    return value;
}

/** @format */
class NgxMatDatatablePaginatorIntl extends MatPaginatorIntl {
    datatableIntl = inject(NgxMatDatatableIntl);
    itemsPerPageLabel = this.datatableIntl.itemsPerPageLabel;
    nextPageLabel = this.datatableIntl.nextPageLabel;
    lastPageLabel = this.datatableIntl.lastPageLabel;
    previousPageLabel = this.datatableIntl.previousPageLabel;
    firstPageLabel = this.datatableIntl.firstPageLabel;
    onLabel = this.datatableIntl.onLabel;
    getRangeLabel = (page, pageSize, length) => {
        return this.datatableIntl.getRangeLabel(page, pageSize, length);
    };
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatablePaginatorIntl, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatablePaginatorIntl });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatablePaginatorIntl, decorators: [{
            type: Injectable
        }] });
class NgxMatDatatableComponent {
    options;
    config;
    rowClicked = new EventEmitter();
    configUpdated = new EventEmitter();
    paginator;
    contentRefs;
    displayedColumns = [];
    dataSource;
    loaded = false;
    searchFormGroup;
    datatableIntl = inject(NgxMatDatatableIntl);
    subscriptions = new Subscription();
    changeDetectorRef = inject(ChangeDetectorRef);
    async ngOnInit() {
        if (!this.options?.service)
            throw new Error(`missing mongoose datatable component service`);
        if (!this.options?.columns)
            throw new Error(`missing mongoose datatable component columns`);
        await this.applyConfig();
        this.buildDisplayColumns();
        this.buildSearchFormGroup();
        this.dataSource = new DatagridDataSource(this.options.service);
        this.changeDetectorRef.detectChanges();
    }
    ngOnDestroy() {
        this.subscriptions.unsubscribe();
    }
    load(intersect) {
        if (!intersect || this.loaded)
            return;
        this.loaded = true;
        this.subscriptions.add(this.paginator?.page.subscribe(() => {
            this.updateConfig();
            this.loadPage();
        }));
        this.loadPage();
    }
    sortColumn(column) {
        if (column.sortable === false)
            return;
        if (!column.order)
            column.order = { index: this.options.columns.filter(c => !!c.order).length, dir: 'asc' };
        else if (column.order.dir === 'asc')
            column.order.dir = 'desc';
        else {
            delete column.order;
            this.consolidateOrderIndex();
        }
        this.paginator.pageIndex = 0;
        this.loadPage();
    }
    redraw(match) {
        this.dataSource.redraw(match);
    }
    exporting = false;
    async export() {
        this.exporting = true;
        try {
            const columns = this.buildRequestColumns();
            const order = this.buildOrder(columns);
            const max = Math.min(Math.floor(5 / this.dataSource.rowSize), this.dataSource.recordsFiltered);
            const chunks = [];
            for (let i = 0; i < Math.ceil(this.dataSource.recordsFiltered / max); ++i) {
                chunks.push({ start: i, length: max });
            }
            const data = (await Promise.all(chunks.map(c => this.options.service({ draw: Date.now().toString(), columns, order, start: c.start, length: c.length })))).reduce((pv, cv) => (pv.push(...cv.data), pv), []);
            const rows = [];
            for (let d of data) {
                const row = {};
                for (let c of this.options.columns) {
                    if (c.hidden)
                        continue;
                    let value = get(d, c.property);
                    if (c.export)
                        c.export(row, value, d);
                    else {
                        if (c.transform)
                            value = c.transform(value, d);
                        switch (c.type) {
                            case 'select':
                                this.buildExportSelectColumn(c, row, value);
                                break;
                            case 'duration':
                                this.buildExportDurationColumn(c, row, value);
                                break;
                            default:
                                row[c.header] = value;
                        }
                    }
                }
                rows.push(row);
            }
            const workbook = XLSX.utils.book_new();
            const worksheet = XLSX.utils.json_to_sheet(rows);
            XLSX.utils.book_append_sheet(workbook, worksheet, 'export');
            const filename = typeof this.options.actions?.export === 'string' ? this.options.actions.export : 'export';
            await XLSX.writeFile(workbook, `${filename}-${Date.now()}.xlsx`);
        }
        finally {
            this.exporting = false;
        }
    }
    async buildExportSelectColumn(column, row, value) {
        row[column.header] = (await lastValueFrom(column.options)).find(option => option.value === value)?.name ?? value;
    }
    async buildExportDurationColumn(column, row, value) {
        row[`${column.header} ms`] = value;
        row[column.header] = duration(value, column);
    }
    loadPage() {
        const columns = this.buildRequestColumns();
        const order = this.buildOrder(columns);
        this.dataSource.loadData({
            draw: Date.now().toString(),
            columns,
            start: this.paginator.pageIndex,
            length: this.paginator.pageSize,
            order,
            facets: this.options.facets,
        });
    }
    buildOrder(columns) {
        const order = [];
        this.options.columns
            .filter(c => !!c.order)
            .sort((c1, c2) => c1.order.index - c2.order.index)
            .forEach(c => {
            const index = columns.findIndex(column => column.data === (c.sortProperty || c.property));
            if (index !== -1)
                order.push({ column: index, dir: c.order.dir });
        });
        return order;
    }
    updateColumns = [];
    openUpdateColumnDisplay() {
        this.updateColumns = this.options.columns.map(column => ({
            columnDef: column.columnDef,
            header: column.header,
            sticky: column.sticky,
            hidden: column.hidden,
        }));
    }
    reorderColumns(event) {
        moveItemInArray(this.updateColumns, event.previousIndex, event.currentIndex);
    }
    closeUpdateColumnDisplay() {
        let reload = false;
        this.updateColumns.forEach((updated, index) => {
            const columnIndex = this.options.columns.findIndex(c => c.columnDef === updated.columnDef);
            if (columnIndex == -1)
                return;
            if (columnIndex !== index)
                moveItemInArray(this.options.columns, columnIndex, index);
            const column = this.options.columns[index];
            if (updated.sticky !== column.sticky)
                column.sticky = updated.sticky;
            if (updated.hidden !== column.hidden) {
                column.hidden = updated.hidden;
                reload = reload || !updated.hidden;
            }
        });
        this.buildDisplayColumns();
        this.updateConfig();
        if (reload)
            this.loadPage();
    }
    rowClick(row) {
        if (typeof this.options.actions?.rowClick === 'boolean') {
            this.rowClicked.emit(row);
        }
        else if (typeof this.options.actions?.rowClick === 'function') {
            this.options.actions.rowClick(row);
            this.rowClicked.emit(row);
        }
    }
    facetClick(column, result) {
        if (!column)
            return;
        const control = this.searchFormGroup?.controls[column.columnDef];
        if (!control)
            return;
        if (result._id !== control.value?.value)
            control.setValue({ value: result._id });
    }
    buildRequestColumns() {
        const columns = [];
        const additionalColumns = [];
        if (this.options.additionalProperties) {
            this.options.additionalProperties.forEach(property => this.addAdditionalColumn(additionalColumns, property));
        }
        this.options.columns.forEach(c => {
            if (c.hidden)
                return;
            const column = { data: c.property, name: c.columnDef, searchable: c.searchable };
            if (c.sortProperty && c.order)
                this.addAdditionalColumn(additionalColumns, c.sortProperty);
            if (c.searchable) {
                const control = this.searchFormGroup.controls[c.columnDef];
                if (control.value) {
                    if (c.searchProperty)
                        this.addAdditionalColumn(additionalColumns, c.searchProperty, control.value);
                    else
                        column.search = control.value;
                }
            }
            if (c.additionalProperties) {
                c.additionalProperties.forEach(property => this.addAdditionalColumn(additionalColumns, property));
            }
            columns.push(column);
        });
        for (let additionalColumn of additionalColumns) {
            const c = columns.find(c => c.data === additionalColumn.data);
            if (!c)
                columns.push(additionalColumn);
            else if (additionalColumn.search && !c.search)
                c.search = additionalColumn.search;
        }
        return columns;
    }
    addAdditionalColumn(additionalColumns, data, search) {
        let column = additionalColumns.find(c => c.data === data);
        if (!column)
            additionalColumns.push((column = { data }));
        if (search) {
            column.search = search;
            column.searchable = true;
        }
        return column;
    }
    buildDisplayColumns() {
        const displayedColumns = [];
        this.options.columns.forEach(column => {
            if (column.hidden)
                return;
            displayedColumns.push(column.columnDef);
            if (column.type && ['number', 'date', 'duration'].includes(column.type)) {
                if (!column.locale)
                    column.locale = this.datatableIntl.locale;
            }
        });
        this.displayedColumns = displayedColumns;
    }
    buildSearchFormGroup() {
        this.searchFormGroup = new FormGroup(this.options.columns.reduce((controls, column) => {
            if (column.searchable) {
                controls[column.columnDef] = new FormControl({ value: undefined, disabled: false });
            }
            return controls;
        }, {}));
        this.subscriptions.add(this.searchFormGroup.valueChanges.pipe(debounceTime(500)).subscribe(value => {
            this.paginator.pageIndex = 0;
            this.loadPage();
        }));
    }
    consolidateOrderIndex() {
        let index = 0;
        this.options.columns
            .filter(c => !!c.order)
            .sort((c1, c2) => c1.order.index - c2.order.index)
            .forEach(c => (c.order.index = index++));
    }
    async applyConfig() {
        if (this.options?.configService?.get) {
            const config = await this.options.configService.get();
            this.config = config ?? this.config;
        }
        if (this.options?.columns && this.config?.columns) {
            this.config.columns.forEach((updated, index) => {
                const columnIndex = this.options.columns.findIndex(c => c.columnDef === updated.columnDef);
                if (columnIndex == -1)
                    return;
                if (columnIndex !== index)
                    moveItemInArray(this.options.columns, columnIndex, index);
                const column = this.options.columns[index];
                if (updated.sticky !== column.sticky)
                    column.sticky = updated.sticky;
                if (updated.hidden !== column.hidden)
                    column.hidden = updated.hidden;
            });
            this.buildDisplayColumns();
        }
        if (this.options && typeof this.config?.pageSizeOptionsIndex === 'number') {
            this.options.pageSizeOptionsIndex = this.config.pageSizeOptionsIndex;
        }
    }
    updateConfig() {
        const pageSizeOptions = this.options.pageSizeOptions ?? [5, 10, 20, 50, 100];
        const pageSizeOptionsIndex = pageSizeOptions.indexOf(this.paginator?.pageSize ?? 0);
        const columns = this.options.columns.map(c => ({ columnDef: c.columnDef, sticky: c.sticky, hidden: c.hidden }));
        this.config = { columns, pageSizeOptionsIndex };
        this.configUpdated.next(this.config);
        if (this.options?.configService?.set)
            this.options.configService.set(this.config);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatableComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.4", type: NgxMatDatatableComponent, isStandalone: true, selector: "ngx-mat-datatable", inputs: { options: "options", config: "config" }, outputs: { rowClicked: "rowClicked", configUpdated: "configUpdated" }, providers: [{ provide: MatPaginatorIntl, useClass: NgxMatDatatablePaginatorIntl }], queries: [{ propertyName: "contentRefs", predicate: NgxMatDatatableContentDirective }], viewQueries: [{ propertyName: "paginator", first: true, predicate: MatPaginator, descendants: true }], ngImport: i0, template: "<!-- @format -->\n\n@if (dataSource) {\n  <div id=\"container\">\n    <ng-container *ngTemplateOutlet=\"headTmpl\"></ng-container>\n\n    <div id=\"table-container\" intersectionObserver (intersection)=\"load($event.intersect)\">\n      <table id=\"table\" mat-table [fixedLayout]=\"false\" [dataSource]=\"dataSource\" multiTemplateDataRows>\n        @for (column of options.columns; track column) {\n          <ng-container [matColumnDef]=\"column.columnDef\" [sticky]=\"column.sticky\">\n            <th\n              mat-header-cell\n              *matHeaderCellDef\n              [class.searchable]=\"column.searchable\"\n              [style.min-width.px]=\"column.minWidth || options.columnMinWith\">\n              <ng-container *ngTemplateOutlet=\"headerTmpl; context: { column }\"></ng-container>\n            </th>\n            <td\n              mat-cell\n              *matCellDef=\"let row\"\n              [style.min-width.px]=\"column.minWidth || options.columnMinWith\"\n              [style.color]=\"row | color: column : options\"\n              [style.background-color]=\"row | backgroundColor: column : options\">\n              <ng-container *ngTemplateOutlet=\"cellTmpl; context: { column, row }\"></ng-container>\n            </td>\n          </ng-container>\n        }\n\n        <tr mat-header-row *matHeaderRowDef=\"displayedColumns; sticky: true\"></tr>\n        <tr\n          mat-row\n          *matRowDef=\"let row; columns: displayedColumns\"\n          [class.has-click]=\"options.actions?.rowClick\"\n          (click)=\"rowClick(row)\"></tr>\n        <tr class=\"mat-row\" *matNoDataRow>\n          <td [attr.colspan]=\"displayedColumns.length\">\n            <div id=\"no-data\">\n              <span id=\"no-data-label\"> {{ datatableIntl.noDateLabel }}</span>\n            </div>\n          </td>\n        </tr>\n      </table>\n    </div>\n\n    <mat-paginator\n      id=\"paginator\"\n      [length]=\"dataSource.recordsFiltered\"\n      [pageSizeOptions]=\"options.pageSizeOptions || [5, 10, 20, 50, 100]\"\n      [pageSize]=\"(options.pageSizeOptions ?? [5, 10, 20, 50, 100])[options.pageSizeOptionsIndex ?? 0]\"\n      [showFirstLastButtons]=\"true\">\n    </mat-paginator>\n  </div>\n}\n<div id=\"loading\" *ngIf=\"!dataSource || (dataSource.loading$ | async)\" @fade>\n  <ng-content select=\"[loader-spinner]\">\n    <mat-spinner loader-spinner></mat-spinner>\n  </ng-content>\n</div>\n\n<ng-template #headTmpl>\n  <div id=\"head\">\n    <div id=\"head-start\">\n      @for (facetOptions of options.facets | filter: { position: 'start' }; track facetOptions) {\n        <ng-container *ngTemplateOutlet=\"facetsTmpl; context: { facetOptions }\"></ng-container>\n      }\n      @for (action of options.actions?.user | filter: { position: 'start' }; track action) {\n        <ng-container *ngTemplateOutlet=\"actionTmpl; context: { action }\"></ng-container>\n      }\n    </div>\n\n    <div id=\"head-center\">\n      @for (facetOptions of options.facets | filter: { position: 'center' }; track facetOptions) {\n        <ng-container *ngTemplateOutlet=\"facetsTmpl; context: { facetOptions }\"></ng-container>\n      }\n      @for (action of options.actions?.user | filter: { position: 'center' }; track action) {\n        <ng-container *ngTemplateOutlet=\"actionTmpl; context: { action }\"></ng-container>\n      }\n    </div>\n\n    <div id=\"head-end\">\n      @for (facetOptions of options.facets | filter: { position: 'end' }; track facetOptions) {\n        <ng-container *ngTemplateOutlet=\"facetsTmpl; context: { facetOptions }\"></ng-container>\n      }\n      @for (action of options.actions?.user | filter: { position: 'end' }; track action) {\n        <ng-container *ngTemplateOutlet=\"actionTmpl; context: { action }\"></ng-container>\n      }\n\n      <div\n        *ngIf=\"\n          options.actions?.columns?.hideAndShow || options.actions?.columns?.sticky || options.actions?.columns?.reorder\n        \">\n        <button\n          mat-icon-button\n          color=\"primary\"\n          class=\"icon-only action\"\n          [matTooltip]=\"options.actions?.columns?.tooltip || 'Afficher / masquer des colonnes'\"\n          [matMenuTriggerFor]=\"columnsMenu\"\n          (menuOpened)=\"openUpdateColumnDisplay()\"\n          (menuClosed)=\"closeUpdateColumnDisplay()\">\n          <mat-icon>view_column</mat-icon>\n        </button>\n      </div>\n\n      <div *ngIf=\"options.actions?.export\" class=\"action\">\n        <button mat-icon-button color=\"primary\" [disabled]=\"exporting\" (click)=\"export()\">\n          <mat-icon>download</mat-icon>\n        </button>\n        <div class=\"action-loader\" *ngIf=\"exporting\" @fade>\n          <mat-spinner [diameter]=\"32\"></mat-spinner>\n        </div>\n      </div>\n\n      <div *ngIf=\"options.actions?.refresh\" class=\"action\">\n        <button mat-icon-button color=\"primary\" [disabled]=\"dataSource.loading$ | async\" (click)=\"loadPage()\">\n          <mat-icon>sync</mat-icon>\n        </button>\n        <div class=\"action-loader\" *ngIf=\"dataSource.loading$ | async\" @fade>\n          <mat-spinner [diameter]=\"32\"></mat-spinner>\n        </div>\n      </div>\n    </div>\n  </div>\n</ng-template>\n\n<mat-menu #columnsMenu=\"matMenu\" class=\"datatable-columns-menu\">\n  <div\n    id=\"column-options\"\n    cdkDropList\n    has-handle\n    [cdkDropListDisabled]=\"!options.actions?.columns?.reorder\"\n    (cdkDropListDropped)=\"reorderColumns($event)\">\n    @for (column of updateColumns; track column) {\n      @if (['_select', '_rownumber'].includes(column.header)) {\n        <div mat-list-item cdkDrag></div>\n      } @else {\n        <div class=\"column-options-item\" mat-list-item cdkDrag (click)=\"$event.stopPropagation()\">\n          <button\n            *ngIf=\"options.actions?.columns?.hideAndShow\"\n            mat-icon-button\n            size=\"small\"\n            color=\"primary\"\n            [class]=\"column.hidden ? 'toggle-off' : 'toggle-on'\"\n            (click)=\"column.hidden = !column.hidden\"\n            [style.margin-right.px]=\"8\">\n            <mat-icon>\n              @if (!column.hidden) {\n                visibility\n              } @else {\n                visibility_off\n              }\n            </mat-icon>\n          </button>\n          <button\n            *ngIf=\"options.actions?.columns?.sticky\"\n            mat-icon-button\n            size=\"small\"\n            color=\"primary\"\n            [class]=\"column.sticky ? 'toggle-on' : 'toggle-off'\"\n            (click)=\"column.sticky = !column.sticky\"\n            [style.margin-right.px]=\"8\">\n            <mat-icon>push_pin </mat-icon>\n          </button>\n          <span [style.margin-right.px]=\"8\">{{ column.header }}</span>\n          <mat-icon\n            *ngIf=\"options.actions?.columns?.reorder\"\n            size=\"small\"\n            class=\"handle\"\n            cdkDragHandle\n            [style.margin]=\"'0 8px 0 auto'\">\n            open_with\n          </mat-icon>\n        </div>\n      }\n    }\n  </div>\n</mat-menu>\n\n<ng-template #headerTmpl let-column=\"column\">\n  <div class=\"header-container\" [matTooltip]=\"column.tooltip\">\n    <div class=\"header\" [formGroup]=\"searchFormGroup\">\n      @if (column.searchable) {\n        @switch (column.type) {\n          @case ('text') {\n            <lib-header-text-filter [column]=\"column\" [formControlName]=\"column.columnDef\"></lib-header-text-filter>\n          }\n          @case ('number') {\n            <lib-header-number-filter [column]=\"column\" [formControlName]=\"column.columnDef\"></lib-header-number-filter>\n          }\n          @case ('select') {\n            <lib-header-select-filter [column]=\"column\" [formControlName]=\"column.columnDef\"></lib-header-select-filter>\n          }\n          @case ('autocomplete') {\n            <lib-header-autocomplete-filter\n              [column]=\"column\"\n              [formControlName]=\"column.columnDef\"></lib-header-autocomplete-filter>\n          }\n          @case ('checkbox') {\n            <lib-header-checkbox-filter\n              [column]=\"column\"\n              [formControlName]=\"column.columnDef\"></lib-header-checkbox-filter>\n          }\n          @case ('date') {\n            <lib-header-date-filter [column]=\"column\" [formControlName]=\"column.columnDef\"></lib-header-date-filter>\n          }\n          @case ('duration') {\n            <lib-header-duration-filter\n              [column]=\"column\"\n              [formControlName]=\"column.columnDef\"></lib-header-duration-filter>\n          }\n          @default {\n            <span>{{ column.header }}</span>\n          }\n        }\n      } @else {\n        <span>{{ column.header }}</span>\n      }\n      <ng-container *ngTemplateOutlet=\"headerActionsTmpl; context: { column }\"></ng-container>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #headerActionsTmpl let-column=\"column\">\n  <div class=\"header-actions\">\n    <ng-container *ngIf=\"column.sortable\">\n      <button\n        class=\"sort-btn\"\n        mat-icon-button\n        size=\"small\"\n        (click)=\"sortColumn(column)\"\n        [matBadgeHidden]=\"!column.order\"\n        [matBadge]=\"column.order?.index + 1\">\n        @switch (column.order?.dir) {\n          @case ('asc') {\n            <mat-icon size=\"small\">arrow_upward</mat-icon>\n          }\n          @case ('desc') {\n            <mat-icon size=\"small\">arrow_downward</mat-icon>\n          }\n          @default {\n            <mat-icon size=\"small\">sort</mat-icon>\n          }\n        }\n      </button>\n    </ng-container>\n  </div>\n</ng-template>\n\n<ng-template #cellTmpl let-column=\"column\" let-row=\"row\">\n  @defer (on viewport) {\n    <div class=\"cell\" [style.place-content]=\"column.align\" [style.max-height.px]=\"options.rowMaxHeight\">\n      @let value = row | get: column.property;\n      @if (column.cellComponent) {\n        <ng-container *ngComponentOutlet=\"column.cellComponent; inputs: { column, row, value }\" />\n      } @else if (column.cellContentId) {\n        @let cell = contentRefs | findContent: column.cellContentId;\n        @if (cell) {\n          <ng-container *ngTemplateOutlet=\"cell.templateRef; context: { column, row, value }\" />\n        }\n      } @else {\n        @if (column.prefixContentId) {\n          @let cell = contentRefs | findContent: column.prefixContentId;\n          @if (cell) {\n            <ng-container *ngTemplateOutlet=\"cell.templateRef; context: { column, row, value }\" />\n          }\n        } @else if (column.prefix) {\n          <span [outerHTML]=\"column.prefix | safeHtml\"></span>\n        }\n        @switch (column.type) {\n          @case ('number') {\n            <lib-cell-number-value [column]=\"column\" [row]=\"row\"></lib-cell-number-value>\n          }\n          @case ('select') {\n            <lib-cell-select-value [column]=\"column\" [row]=\"row\"></lib-cell-select-value>\n          }\n          @case ('checkbox') {\n            <lib-cell-checkbox-value [column]=\"column\" [row]=\"row\"></lib-cell-checkbox-value>\n          }\n          @case ('date') {\n            <lib-cell-date-value [column]=\"column\" [row]=\"row\"></lib-cell-date-value>\n          }\n          @case ('duration') {\n            <lib-cell-duration-value [column]=\"column\" [row]=\"row\"></lib-cell-duration-value>\n          }\n          @default {\n            <span [outerHTML]=\"value | transform: row : column | safeHtml\"></span>\n          }\n        }\n        @if (column.suffixContentId) {\n          @let cell = contentRefs | findContent: column.suffixContentId;\n          @if (cell) {\n            <ng-container *ngTemplateOutlet=\"cell.templateRef; context: { column, row, value }\" />\n          }\n        } @else if (column.suffix) {\n          <span [outerHTML]=\"column.suffix | safeHtml\"></span>\n        }\n      }\n    </div>\n  } @placeholder {\n    <div class=\"cell\"></div>\n  }\n</ng-template>\n\n<ng-template #actionTmpl let-action=\"action\">\n  <div class=\"action user-action\" [matTooltip]=\"action.tooltip\">\n    <button [style.--action-color]=\"action.color\" mat-icon-button (click)=\"action.onclick(this)\">\n      <mat-icon>{{ action.icon }}</mat-icon>\n    </button>\n  </div>\n</ng-template>\n\n<ng-template #facetsTmpl let-facetOptions=\"facetOptions\">\n  @let column = options.columns | find: { property: facetOptions.property };\n  @let data = (dataSource.facets ?? {})[facetOptions.id] | sortFacetEntries: facetOptions;\n  @if (data) {\n    @if (facetOptions.contentId) {\n      @let cell = contentRefs | findContent: facetOptions.contentId;\n      @if (cell) {\n        <ng-container *ngTemplateOutlet=\"cell.templateRef; context: { column, facetOptions, data }\" />\n      }\n    } @else {\n      @let size = facetOptions.size ?? 80;\n      @let fontSize = facetOptions.fontSize ?? '1em';\n      @let total = (data | sum: 'value') || 1;\n      <mat-card class=\"facet\">\n        @if (facetOptions.name) {\n          <mat-card-header>\n            <mat-label>{{ facetOptions.name }}</mat-label>\n          </mat-card-header>\n        }\n        <mat-card-content>\n          @for (d of data; track d) {\n            @let style = facetOptions.style ? facetOptions.style(d._id) : null;\n            @let percent = (d.value / total) * 100;\n            <div\n              class=\"facet-indicator\"\n              [class.has-action]=\"column?.searchable !== false\"\n              (click)=\"facetClick(column, d)\">\n              <lib-progress-spinner [diameter]=\"size\" [color]=\"style?.color\" [fontSize]=\"fontSize\" [value]=\"percent\">\n                <mat-label>{{ style?.name ?? d._id }}</mat-label>\n              </lib-progress-spinner>\n              <mat-label\n                class=\"facet-indicator-label\"\n                [style.font-size]=\"fontSize\"\n                [countUp]=\"d.value\"\n                [options]=\"datatableIntl.numberOptions\"\n                [reanimateOnClick]=\"false\">\n                {{ d.value | number: '0.0-2' }}\n              </mat-label>\n            </div>\n          }\n        </mat-card-content>\n      </mat-card>\n    }\n  }\n</ng-template>\n", styles: [":host{overflow:hidden;display:flex;position:relative;max-height:100%;--ngx-mat-datatable-background: #ffffff;--ngx-mat-datatable-border-color: #ccc;--ngx-mat-datatable-sticky-background: var(--ngx-mat-datatable-background);--ngx-mat-datatable-sticky-border: 1px dashed #e6a93a}#container{display:flex;flex:1 1 100%;box-sizing:border-box;flex-direction:column;position:relative;overflow:hidden;width:100%;background-color:var(--ngx-mat-datatable-background)}#head{width:100%;display:flex;box-sizing:border-box;place-content:end space-between;align-items:end;flex-direction:row;border-bottom:1px solid var(--ngx-mat-datatable-border-color)}#head #head-start,#head #head-center,#head #head-end{display:flex;box-sizing:border-box;align-items:end;flex-direction:row}#head #head-start{place-content:end start}#head #head-center{place-content:end center}#head #head-end{place-content:end end}#head .action{position:relative}#head .action .action-loader{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%)}#head .action.user-action .mat-mdc-icon-button{--mdc-icon-button-icon-color: var(--action-color, var(--mat-sys-primary))}#column-options .column-options-item{overflow:hidden;display:flex;box-sizing:border-box;align-items:center;flex-direction:row;place-content:center start}#column-options .column-options-item button.toggle-off{--mdc-icon-button-icon-color: var(--mdc-icon-button-disabled-icon-color)}#column-options .column-options-item mat-icon.handle{color:var(--mdc-icon-button-disabled-icon-color)}#table-container{flex:1 1 100%;overflow:auto;width:100%;scrollbar-width:thin}#table{width:100%;max-height:100%;--mat-table-background-color: var(--ngx-mat-datatable-background);--mat-table-row-item-outline-color: var(--ngx-mat-datatable-border-color)}#table ::ng-deep .mat-mdc-table-sticky{opacity:1;background:var(--ngx-mat-datatable-sticky-background, var(--ngx-mat-datatable-background, #ffffff))}#table ::ng-deep .mat-mdc-table-sticky.mat-mdc-table-sticky-border-elem-left{border-right:var(--ngx-mat-datatable-sticky-border)}#table ::ng-deep .mat-mdc-header-cell{padding:0 8px}#table ::ng-deep .mat-mdc-header-cell mat-form-field{min-width:auto;flex:1 1 100%;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}#table ::ng-deep .mat-mdc-header-cell mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}#table ::ng-deep .mat-mdc-header-cell mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}#table ::ng-deep .mat-mdc-cell{padding:0 8px}#table ::ng-deep .mat-mdc-row.has-click{cursor:pointer}#table ::ng-deep .mat-mdc-row.has-click:hover .mat-mdc-cell{color:var(--ngx-mat-datatable-hover-color, var(--mat-sys-on-primary))!important;background-color:var(--ngx-mat-datatable-hover-bgcolor, var(--mat-sys-primary))!important}#table ::ng-deep .mat-mdc-row:last-child .mat-mdc-cell{border-bottom-color:var(--mat-table-row-item-outline-color, var(--mat-sys-outline, rgba(0, 0, 0, .12)));border-bottom-width:var(--mat-table-row-item-outline-width, 1px);border-bottom-style:solid}#table .header-container{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row;width:100%;min-height:var(--mat-form-field-container-height, 56px);margin:6px 0}#table .header{width:100%;display:flex;box-sizing:border-box;place-content:center space-between;align-items:center;flex-direction:row}#table .header .header-actions .sort-btn{--mat-badge-container-size: 12px;--mat-badge-line-height: 16px;--mat-badge-text-size: 10px;--mat-badge-legacy-container-size: 18px}#table .cell{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row;width:100%}#table .cell>*{display:inline-flex}#paginator{--mat-paginator-container-background-color: var(--ngx-mat-datatable-background);--mat-form-field-container-height: 24px;--mat-form-field-container-vertical-padding: 4px;--mat-paginator-container-size: 46px;border-top:1px solid var(--ngx-mat-datatable-border-color)}#paginator ::ng-deep .mat-mdc-select{display:flex;height:24px}#paginator ::ng-deep .mat-mdc-paginator-touch-target{height:24px}#paginator ::ng-deep .mat-mdc-paginator-range-actions button{--mdc-icon-button-state-layer-size: 36px;padding:6px}#loading{position:absolute;z-index:200;inset:0;background-color:#00000029;display:flex;box-sizing:border-box;place-content:center center;align-items:center;flex-direction:row}::ng-deep .mat-mdc-icon-button[mat-icon-button][size=small]{--mdc-icon-button-state-layer-size: 30px;--mdc-icon-button-icon-size: 18px}::ng-deep .mat-mdc-icon-button[mat-icon-button][size=small] .mat-mdc-button-touch-target{height:36px;width:36px}::ng-deep .mat-mdc-icon-button[mat-icon-button][size=small] mat-icon{height:18px;width:18px;font-size:18px}.row{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row}#no-data{position:sticky;width:fit-content;left:50%}#no-data #no-data-label{position:relative;margin-left:-50%}.facet{margin:8px;--mdc-elevated-card-container-color: transparent}.facet mat-card-content{display:flex;box-sizing:border-box;place-content:center center;align-items:center;flex-direction:row;flex-wrap:wrap;padding:4px}.facet .facet-indicator{display:flex;box-sizing:border-box;flex-direction:column;place-content:center center;align-items:center;position:relative;margin:4px}.facet .facet-indicator.has-action{cursor:pointer}.facet .facet-indicator .facet-indicator-label{max-width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;line-height:1em;padding:2px}\n"], dependencies: [{ kind: "pipe", type: ColorPipe, name: "color" }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "pipe", type: i1$1.AsyncPipe, name: "async" }, { kind: "pipe", type: i1$1.DecimalPipe, name: "number" }, { kind: "ngmodule", type: DragDropModule }, { kind: "directive", type: i2$1.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep", "cdkDropListElementContainer"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { kind: "directive", type: i2$1.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer", "cdkDragScale"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { kind: "directive", type: i2$1.CdkDragHandle, selector: "[cdkDragHandle]", inputs: ["cdkDragHandleDisabled"] }, { kind: "pipe", type: FindContentPipe, name: "findContent" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "component", type: HeaderAutocompleteFilterComponent, selector: "lib-header-autocomplete-filter", inputs: ["column"] }, { kind: "component", type: HeaderCheckboxFilterComponent, selector: "lib-header-checkbox-filter", inputs: ["column"] }, { kind: "component", type: HeaderDateFilterComponent, selector: "lib-header-date-filter", inputs: ["column"] }, { kind: "component", type: HeaderDurationFilterComponent, selector: "lib-header-duration-filter", inputs: ["column"] }, { kind: "component", type: HeaderNumberFilterComponent, selector: "lib-header-number-filter", inputs: ["column"] }, { kind: "component", type: HeaderSelectFilterComponent, selector: "lib-header-select-filter", inputs: ["column"] }, { kind: "component", type: HeaderTextFilterComponent, selector: "lib-header-text-filter", inputs: ["column"] }, { kind: "ngmodule", type: IntersectionObserverModule }, { kind: "directive", type: i3.IntersectionObserverDirective, selector: "[intersectionObserver]", inputs: ["visitClass", "leaveClass", "removeVisitClass", "removeLeaveClass", "useScroll", "threshold", "autoRemove"], outputs: ["intersection"] }, { kind: "ngmodule", type: MatBadgeModule }, { kind: "directive", type: i5$2.MatBadge, selector: "[matBadge]", inputs: ["matBadgeColor", "matBadgeOverlap", "matBadgeDisabled", "matBadgePosition", "matBadge", "matBadgeDescription", "matBadgeSize", "matBadgeHidden"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "directive", type: i4$1.MatLabel, selector: "mat-label" }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i5$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatMenuModule }, { kind: "component", type: i9.MatMenu, selector: "mat-menu", inputs: ["backdropClass", "aria-label", "aria-labelledby", "aria-describedby", "xPosition", "yPosition", "overlapTrigger", "hasBackdrop", "class", "classList"], outputs: ["closed", "close"], exportAs: ["matMenu"] }, { kind: "directive", type: i9.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", inputs: ["mat-menu-trigger-for", "matMenuTriggerFor", "matMenuTriggerData", "matMenuTriggerRestoreFocus"], outputs: ["menuOpened", "onMenuOpen", "menuClosed", "onMenuClose"], exportAs: ["matMenuTrigger"] }, { kind: "ngmodule", type: MatPaginatorModule }, { kind: "component", type: i10$1.MatPaginator, selector: "mat-paginator", inputs: ["color", "pageIndex", "length", "pageSize", "pageSizeOptions", "hidePageSize", "showFirstLastButtons", "selectConfig", "disabled"], outputs: ["page"], exportAs: ["matPaginator"] }, { kind: "ngmodule", type: MatProgressSpinnerModule }, { kind: "component", type: i1$3.MatProgressSpinner, selector: "mat-progress-spinner, mat-spinner", inputs: ["color", "mode", "value", "diameter", "strokeWidth"], exportAs: ["matProgressSpinner"] }, { kind: "ngmodule", type: MatTableModule }, { kind: "component", type: i12.MatTable, selector: "mat-table, table[mat-table]", exportAs: ["matTable"] }, { kind: "directive", type: i12.MatHeaderCellDef, selector: "[matHeaderCellDef]" }, { kind: "directive", type: i12.MatHeaderRowDef, selector: "[matHeaderRowDef]", inputs: ["matHeaderRowDef", "matHeaderRowDefSticky"] }, { kind: "directive", type: i12.MatColumnDef, selector: "[matColumnDef]", inputs: ["matColumnDef"] }, { kind: "directive", type: i12.MatCellDef, selector: "[matCellDef]" }, { kind: "directive", type: i12.MatRowDef, selector: "[matRowDef]", inputs: ["matRowDefColumns", "matRowDefWhen"] }, { kind: "directive", type: i12.MatHeaderCell, selector: "mat-header-cell, th[mat-header-cell]" }, { kind: "directive", type: i12.MatCell, selector: "mat-cell, td[mat-cell]" }, { kind: "component", type: i12.MatHeaderRow, selector: "mat-header-row, tr[mat-header-row]", exportAs: ["matHeaderRow"] }, { kind: "component", type: i12.MatRow, selector: "mat-row, tr[mat-row]", exportAs: ["matRow"] }, { kind: "directive", type: i12.MatNoDataRow, selector: "ng-template[matNoDataRow]" }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i13.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "pipe", type: BackgroundColorPipe, name: "backgroundColor" }, { kind: "pipe", type: FilterPipe, name: "filter" }, { kind: "pipe", type: SumPipe, name: "sum" }, { kind: "ngmodule", type: MatCardModule }, { kind: "component", type: i14.MatCard, selector: "mat-card", inputs: ["appearance"], exportAs: ["matCard"] }, { kind: "directive", type: i14.MatCardContent, selector: "mat-card-content" }, { kind: "component", type: i14.MatCardHeader, selector: "mat-card-header" }, { kind: "ngmodule", type: CountUpModule }, { kind: "directive", type: i3$3.CountUpDirective, selector: "[countUp]", inputs: ["countUp", "options", "reanimateOnClick"], outputs: ["complete"] }, { kind: "component", type: ProgressSpinnerComponent, selector: "lib-progress-spinner", inputs: ["diameter", "value", "color", "displayValue", "fontSize", "animateInView", "delay"] }, { kind: "pipe", type: FindPipe, name: "find" }, { kind: "pipe", type: SortFacetEntriesPipe, name: "sortFacetEntries" }], animations: [
            trigger('fade', [
                transition(':enter', [
                    style({ opacity: 0 }), // initial
                    animate('0.2s', style({ opacity: 1 })), // final
                ]),
                transition(':leave', [
                    style({ opacity: 1 }), // initial
                    animate('0.2s', style({ opacity: 0 })), // final
                ]),
            ]),
        ], deferBlockDependencies: [() => [import('./eherve-angular-material-datatable-cell-checkbox-value.component-DqbkIJSP.mjs').then(m => m.CellCheckboxValueComponent), import('./eherve-angular-material-datatable-cell-date-value.component-DAZd-ntE.mjs').then(m => m.CellDateValueComponent), import('./eherve-angular-material-datatable-cell-duration-value.component-BTQ-73lT.mjs').then(m => m.CellDurationValueComponent), import('./eherve-angular-material-datatable-cell-number-value.component-CdLU-TE4.mjs').then(m => m.CellNumberValueComponent), import('./eherve-angular-material-datatable-cell-select-value.component-DfQ0N8Ss.mjs').then(m => m.CellSelectValueComponent), i1$1.NgComponentOutlet, i1$1.NgTemplateOutlet, import('./eherve-angular-material-datatable-transform.pipe-BOmcXXZU.mjs').then(m => m.TransformPipe), FindContentPipe, import('./eherve-angular-material-datatable-get.pipe-DAIsow8j.mjs').then(m => m.GetPipe), Promise.resolve().then(function () { return safeHtml_pipe; }).then(m => m.SafeHtmlPipe)]] });
}
i0.ɵɵngDeclareClassMetadataAsync({ minVersion: "18.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatableComponent, resolveDeferredDeps: () => [import('./eherve-angular-material-datatable-cell-checkbox-value.component-DqbkIJSP.mjs').then(m => m.CellCheckboxValueComponent), import('./eherve-angular-material-datatable-cell-date-value.component-DAZd-ntE.mjs').then(m => m.CellDateValueComponent), import('./eherve-angular-material-datatable-cell-duration-value.component-BTQ-73lT.mjs').then(m => m.CellDurationValueComponent), import('./eherve-angular-material-datatable-cell-number-value.component-CdLU-TE4.mjs').then(m => m.CellNumberValueComponent), import('./eherve-angular-material-datatable-cell-select-value.component-DfQ0N8Ss.mjs').then(m => m.CellSelectValueComponent), import('./eherve-angular-material-datatable-transform.pipe-BOmcXXZU.mjs').then(m => m.TransformPipe), import('./eherve-angular-material-datatable-get.pipe-DAIsow8j.mjs').then(m => m.GetPipe), Promise.resolve().then(function () { return safeHtml_pipe; }).then(m => m.SafeHtmlPipe)], resolveMetadata: (CellCheckboxValueComponent, CellDateValueComponent, CellDurationValueComponent, CellNumberValueComponent, CellSelectValueComponent, TransformPipe, GetPipe, SafeHtmlPipe) => ({ decorators: [{
                type: Component,
                args: [{ imports: [
                            CellCheckboxValueComponent,
                            CellDateValueComponent,
                            CellDurationValueComponent,
                            CellNumberValueComponent,
                            CellSelectValueComponent,
                            ColorPipe,
                            CommonModule,
                            TransformPipe,
                            DragDropModule,
                            FindContentPipe,
                            FormsModule,
                            GetPipe,
                            HeaderAutocompleteFilterComponent,
                            HeaderCheckboxFilterComponent,
                            HeaderDateFilterComponent,
                            HeaderDurationFilterComponent,
                            HeaderNumberFilterComponent,
                            HeaderSelectFilterComponent,
                            HeaderTextFilterComponent,
                            IntersectionObserverModule,
                            MatBadgeModule,
                            MatButtonModule,
                            MatFormFieldModule,
                            MatIconModule,
                            MatMenuModule,
                            MatPaginatorModule,
                            MatProgressSpinnerModule,
                            MatTableModule,
                            ReactiveFormsModule,
                            SafeHtmlPipe,
                            MatTooltipModule,
                            BackgroundColorPipe,
                            FilterPipe,
                            SumPipe,
                            MatCardModule,
                            CountUpModule,
                            ProgressSpinnerComponent,
                            FindPipe,
                            SortFacetEntriesPipe,
                        ], providers: [{ provide: MatPaginatorIntl, useClass: NgxMatDatatablePaginatorIntl }], selector: 'ngx-mat-datatable', animations: [
                            trigger('fade', [
                                transition(':enter', [
                                    style({ opacity: 0 }), // initial
                                    animate('0.2s', style({ opacity: 1 })), // final
                                ]),
                                transition(':leave', [
                                    style({ opacity: 1 }), // initial
                                    animate('0.2s', style({ opacity: 0 })), // final
                                ]),
                            ]),
                        ], template: "<!-- @format -->\n\n@if (dataSource) {\n  <div id=\"container\">\n    <ng-container *ngTemplateOutlet=\"headTmpl\"></ng-container>\n\n    <div id=\"table-container\" intersectionObserver (intersection)=\"load($event.intersect)\">\n      <table id=\"table\" mat-table [fixedLayout]=\"false\" [dataSource]=\"dataSource\" multiTemplateDataRows>\n        @for (column of options.columns; track column) {\n          <ng-container [matColumnDef]=\"column.columnDef\" [sticky]=\"column.sticky\">\n            <th\n              mat-header-cell\n              *matHeaderCellDef\n              [class.searchable]=\"column.searchable\"\n              [style.min-width.px]=\"column.minWidth || options.columnMinWith\">\n              <ng-container *ngTemplateOutlet=\"headerTmpl; context: { column }\"></ng-container>\n            </th>\n            <td\n              mat-cell\n              *matCellDef=\"let row\"\n              [style.min-width.px]=\"column.minWidth || options.columnMinWith\"\n              [style.color]=\"row | color: column : options\"\n              [style.background-color]=\"row | backgroundColor: column : options\">\n              <ng-container *ngTemplateOutlet=\"cellTmpl; context: { column, row }\"></ng-container>\n            </td>\n          </ng-container>\n        }\n\n        <tr mat-header-row *matHeaderRowDef=\"displayedColumns; sticky: true\"></tr>\n        <tr\n          mat-row\n          *matRowDef=\"let row; columns: displayedColumns\"\n          [class.has-click]=\"options.actions?.rowClick\"\n          (click)=\"rowClick(row)\"></tr>\n        <tr class=\"mat-row\" *matNoDataRow>\n          <td [attr.colspan]=\"displayedColumns.length\">\n            <div id=\"no-data\">\n              <span id=\"no-data-label\"> {{ datatableIntl.noDateLabel }}</span>\n            </div>\n          </td>\n        </tr>\n      </table>\n    </div>\n\n    <mat-paginator\n      id=\"paginator\"\n      [length]=\"dataSource.recordsFiltered\"\n      [pageSizeOptions]=\"options.pageSizeOptions || [5, 10, 20, 50, 100]\"\n      [pageSize]=\"(options.pageSizeOptions ?? [5, 10, 20, 50, 100])[options.pageSizeOptionsIndex ?? 0]\"\n      [showFirstLastButtons]=\"true\">\n    </mat-paginator>\n  </div>\n}\n<div id=\"loading\" *ngIf=\"!dataSource || (dataSource.loading$ | async)\" @fade>\n  <ng-content select=\"[loader-spinner]\">\n    <mat-spinner loader-spinner></mat-spinner>\n  </ng-content>\n</div>\n\n<ng-template #headTmpl>\n  <div id=\"head\">\n    <div id=\"head-start\">\n      @for (facetOptions of options.facets | filter: { position: 'start' }; track facetOptions) {\n        <ng-container *ngTemplateOutlet=\"facetsTmpl; context: { facetOptions }\"></ng-container>\n      }\n      @for (action of options.actions?.user | filter: { position: 'start' }; track action) {\n        <ng-container *ngTemplateOutlet=\"actionTmpl; context: { action }\"></ng-container>\n      }\n    </div>\n\n    <div id=\"head-center\">\n      @for (facetOptions of options.facets | filter: { position: 'center' }; track facetOptions) {\n        <ng-container *ngTemplateOutlet=\"facetsTmpl; context: { facetOptions }\"></ng-container>\n      }\n      @for (action of options.actions?.user | filter: { position: 'center' }; track action) {\n        <ng-container *ngTemplateOutlet=\"actionTmpl; context: { action }\"></ng-container>\n      }\n    </div>\n\n    <div id=\"head-end\">\n      @for (facetOptions of options.facets | filter: { position: 'end' }; track facetOptions) {\n        <ng-container *ngTemplateOutlet=\"facetsTmpl; context: { facetOptions }\"></ng-container>\n      }\n      @for (action of options.actions?.user | filter: { position: 'end' }; track action) {\n        <ng-container *ngTemplateOutlet=\"actionTmpl; context: { action }\"></ng-container>\n      }\n\n      <div\n        *ngIf=\"\n          options.actions?.columns?.hideAndShow || options.actions?.columns?.sticky || options.actions?.columns?.reorder\n        \">\n        <button\n          mat-icon-button\n          color=\"primary\"\n          class=\"icon-only action\"\n          [matTooltip]=\"options.actions?.columns?.tooltip || 'Afficher / masquer des colonnes'\"\n          [matMenuTriggerFor]=\"columnsMenu\"\n          (menuOpened)=\"openUpdateColumnDisplay()\"\n          (menuClosed)=\"closeUpdateColumnDisplay()\">\n          <mat-icon>view_column</mat-icon>\n        </button>\n      </div>\n\n      <div *ngIf=\"options.actions?.export\" class=\"action\">\n        <button mat-icon-button color=\"primary\" [disabled]=\"exporting\" (click)=\"export()\">\n          <mat-icon>download</mat-icon>\n        </button>\n        <div class=\"action-loader\" *ngIf=\"exporting\" @fade>\n          <mat-spinner [diameter]=\"32\"></mat-spinner>\n        </div>\n      </div>\n\n      <div *ngIf=\"options.actions?.refresh\" class=\"action\">\n        <button mat-icon-button color=\"primary\" [disabled]=\"dataSource.loading$ | async\" (click)=\"loadPage()\">\n          <mat-icon>sync</mat-icon>\n        </button>\n        <div class=\"action-loader\" *ngIf=\"dataSource.loading$ | async\" @fade>\n          <mat-spinner [diameter]=\"32\"></mat-spinner>\n        </div>\n      </div>\n    </div>\n  </div>\n</ng-template>\n\n<mat-menu #columnsMenu=\"matMenu\" class=\"datatable-columns-menu\">\n  <div\n    id=\"column-options\"\n    cdkDropList\n    has-handle\n    [cdkDropListDisabled]=\"!options.actions?.columns?.reorder\"\n    (cdkDropListDropped)=\"reorderColumns($event)\">\n    @for (column of updateColumns; track column) {\n      @if (['_select', '_rownumber'].includes(column.header)) {\n        <div mat-list-item cdkDrag></div>\n      } @else {\n        <div class=\"column-options-item\" mat-list-item cdkDrag (click)=\"$event.stopPropagation()\">\n          <button\n            *ngIf=\"options.actions?.columns?.hideAndShow\"\n            mat-icon-button\n            size=\"small\"\n            color=\"primary\"\n            [class]=\"column.hidden ? 'toggle-off' : 'toggle-on'\"\n            (click)=\"column.hidden = !column.hidden\"\n            [style.margin-right.px]=\"8\">\n            <mat-icon>\n              @if (!column.hidden) {\n                visibility\n              } @else {\n                visibility_off\n              }\n            </mat-icon>\n          </button>\n          <button\n            *ngIf=\"options.actions?.columns?.sticky\"\n            mat-icon-button\n            size=\"small\"\n            color=\"primary\"\n            [class]=\"column.sticky ? 'toggle-on' : 'toggle-off'\"\n            (click)=\"column.sticky = !column.sticky\"\n            [style.margin-right.px]=\"8\">\n            <mat-icon>push_pin </mat-icon>\n          </button>\n          <span [style.margin-right.px]=\"8\">{{ column.header }}</span>\n          <mat-icon\n            *ngIf=\"options.actions?.columns?.reorder\"\n            size=\"small\"\n            class=\"handle\"\n            cdkDragHandle\n            [style.margin]=\"'0 8px 0 auto'\">\n            open_with\n          </mat-icon>\n        </div>\n      }\n    }\n  </div>\n</mat-menu>\n\n<ng-template #headerTmpl let-column=\"column\">\n  <div class=\"header-container\" [matTooltip]=\"column.tooltip\">\n    <div class=\"header\" [formGroup]=\"searchFormGroup\">\n      @if (column.searchable) {\n        @switch (column.type) {\n          @case ('text') {\n            <lib-header-text-filter [column]=\"column\" [formControlName]=\"column.columnDef\"></lib-header-text-filter>\n          }\n          @case ('number') {\n            <lib-header-number-filter [column]=\"column\" [formControlName]=\"column.columnDef\"></lib-header-number-filter>\n          }\n          @case ('select') {\n            <lib-header-select-filter [column]=\"column\" [formControlName]=\"column.columnDef\"></lib-header-select-filter>\n          }\n          @case ('autocomplete') {\n            <lib-header-autocomplete-filter\n              [column]=\"column\"\n              [formControlName]=\"column.columnDef\"></lib-header-autocomplete-filter>\n          }\n          @case ('checkbox') {\n            <lib-header-checkbox-filter\n              [column]=\"column\"\n              [formControlName]=\"column.columnDef\"></lib-header-checkbox-filter>\n          }\n          @case ('date') {\n            <lib-header-date-filter [column]=\"column\" [formControlName]=\"column.columnDef\"></lib-header-date-filter>\n          }\n          @case ('duration') {\n            <lib-header-duration-filter\n              [column]=\"column\"\n              [formControlName]=\"column.columnDef\"></lib-header-duration-filter>\n          }\n          @default {\n            <span>{{ column.header }}</span>\n          }\n        }\n      } @else {\n        <span>{{ column.header }}</span>\n      }\n      <ng-container *ngTemplateOutlet=\"headerActionsTmpl; context: { column }\"></ng-container>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #headerActionsTmpl let-column=\"column\">\n  <div class=\"header-actions\">\n    <ng-container *ngIf=\"column.sortable\">\n      <button\n        class=\"sort-btn\"\n        mat-icon-button\n        size=\"small\"\n        (click)=\"sortColumn(column)\"\n        [matBadgeHidden]=\"!column.order\"\n        [matBadge]=\"column.order?.index + 1\">\n        @switch (column.order?.dir) {\n          @case ('asc') {\n            <mat-icon size=\"small\">arrow_upward</mat-icon>\n          }\n          @case ('desc') {\n            <mat-icon size=\"small\">arrow_downward</mat-icon>\n          }\n          @default {\n            <mat-icon size=\"small\">sort</mat-icon>\n          }\n        }\n      </button>\n    </ng-container>\n  </div>\n</ng-template>\n\n<ng-template #cellTmpl let-column=\"column\" let-row=\"row\">\n  @defer (on viewport) {\n    <div class=\"cell\" [style.place-content]=\"column.align\" [style.max-height.px]=\"options.rowMaxHeight\">\n      @let value = row | get: column.property;\n      @if (column.cellComponent) {\n        <ng-container *ngComponentOutlet=\"column.cellComponent; inputs: { column, row, value }\" />\n      } @else if (column.cellContentId) {\n        @let cell = contentRefs | findContent: column.cellContentId;\n        @if (cell) {\n          <ng-container *ngTemplateOutlet=\"cell.templateRef; context: { column, row, value }\" />\n        }\n      } @else {\n        @if (column.prefixContentId) {\n          @let cell = contentRefs | findContent: column.prefixContentId;\n          @if (cell) {\n            <ng-container *ngTemplateOutlet=\"cell.templateRef; context: { column, row, value }\" />\n          }\n        } @else if (column.prefix) {\n          <span [outerHTML]=\"column.prefix | safeHtml\"></span>\n        }\n        @switch (column.type) {\n          @case ('number') {\n            <lib-cell-number-value [column]=\"column\" [row]=\"row\"></lib-cell-number-value>\n          }\n          @case ('select') {\n            <lib-cell-select-value [column]=\"column\" [row]=\"row\"></lib-cell-select-value>\n          }\n          @case ('checkbox') {\n            <lib-cell-checkbox-value [column]=\"column\" [row]=\"row\"></lib-cell-checkbox-value>\n          }\n          @case ('date') {\n            <lib-cell-date-value [column]=\"column\" [row]=\"row\"></lib-cell-date-value>\n          }\n          @case ('duration') {\n            <lib-cell-duration-value [column]=\"column\" [row]=\"row\"></lib-cell-duration-value>\n          }\n          @default {\n            <span [outerHTML]=\"value | transform: row : column | safeHtml\"></span>\n          }\n        }\n        @if (column.suffixContentId) {\n          @let cell = contentRefs | findContent: column.suffixContentId;\n          @if (cell) {\n            <ng-container *ngTemplateOutlet=\"cell.templateRef; context: { column, row, value }\" />\n          }\n        } @else if (column.suffix) {\n          <span [outerHTML]=\"column.suffix | safeHtml\"></span>\n        }\n      }\n    </div>\n  } @placeholder {\n    <div class=\"cell\"></div>\n  }\n</ng-template>\n\n<ng-template #actionTmpl let-action=\"action\">\n  <div class=\"action user-action\" [matTooltip]=\"action.tooltip\">\n    <button [style.--action-color]=\"action.color\" mat-icon-button (click)=\"action.onclick(this)\">\n      <mat-icon>{{ action.icon }}</mat-icon>\n    </button>\n  </div>\n</ng-template>\n\n<ng-template #facetsTmpl let-facetOptions=\"facetOptions\">\n  @let column = options.columns | find: { property: facetOptions.property };\n  @let data = (dataSource.facets ?? {})[facetOptions.id] | sortFacetEntries: facetOptions;\n  @if (data) {\n    @if (facetOptions.contentId) {\n      @let cell = contentRefs | findContent: facetOptions.contentId;\n      @if (cell) {\n        <ng-container *ngTemplateOutlet=\"cell.templateRef; context: { column, facetOptions, data }\" />\n      }\n    } @else {\n      @let size = facetOptions.size ?? 80;\n      @let fontSize = facetOptions.fontSize ?? '1em';\n      @let total = (data | sum: 'value') || 1;\n      <mat-card class=\"facet\">\n        @if (facetOptions.name) {\n          <mat-card-header>\n            <mat-label>{{ facetOptions.name }}</mat-label>\n          </mat-card-header>\n        }\n        <mat-card-content>\n          @for (d of data; track d) {\n            @let style = facetOptions.style ? facetOptions.style(d._id) : null;\n            @let percent = (d.value / total) * 100;\n            <div\n              class=\"facet-indicator\"\n              [class.has-action]=\"column?.searchable !== false\"\n              (click)=\"facetClick(column, d)\">\n              <lib-progress-spinner [diameter]=\"size\" [color]=\"style?.color\" [fontSize]=\"fontSize\" [value]=\"percent\">\n                <mat-label>{{ style?.name ?? d._id }}</mat-label>\n              </lib-progress-spinner>\n              <mat-label\n                class=\"facet-indicator-label\"\n                [style.font-size]=\"fontSize\"\n                [countUp]=\"d.value\"\n                [options]=\"datatableIntl.numberOptions\"\n                [reanimateOnClick]=\"false\">\n                {{ d.value | number: '0.0-2' }}\n              </mat-label>\n            </div>\n          }\n        </mat-card-content>\n      </mat-card>\n    }\n  }\n</ng-template>\n", styles: [":host{overflow:hidden;display:flex;position:relative;max-height:100%;--ngx-mat-datatable-background: #ffffff;--ngx-mat-datatable-border-color: #ccc;--ngx-mat-datatable-sticky-background: var(--ngx-mat-datatable-background);--ngx-mat-datatable-sticky-border: 1px dashed #e6a93a}#container{display:flex;flex:1 1 100%;box-sizing:border-box;flex-direction:column;position:relative;overflow:hidden;width:100%;background-color:var(--ngx-mat-datatable-background)}#head{width:100%;display:flex;box-sizing:border-box;place-content:end space-between;align-items:end;flex-direction:row;border-bottom:1px solid var(--ngx-mat-datatable-border-color)}#head #head-start,#head #head-center,#head #head-end{display:flex;box-sizing:border-box;align-items:end;flex-direction:row}#head #head-start{place-content:end start}#head #head-center{place-content:end center}#head #head-end{place-content:end end}#head .action{position:relative}#head .action .action-loader{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%)}#head .action.user-action .mat-mdc-icon-button{--mdc-icon-button-icon-color: var(--action-color, var(--mat-sys-primary))}#column-options .column-options-item{overflow:hidden;display:flex;box-sizing:border-box;align-items:center;flex-direction:row;place-content:center start}#column-options .column-options-item button.toggle-off{--mdc-icon-button-icon-color: var(--mdc-icon-button-disabled-icon-color)}#column-options .column-options-item mat-icon.handle{color:var(--mdc-icon-button-disabled-icon-color)}#table-container{flex:1 1 100%;overflow:auto;width:100%;scrollbar-width:thin}#table{width:100%;max-height:100%;--mat-table-background-color: var(--ngx-mat-datatable-background);--mat-table-row-item-outline-color: var(--ngx-mat-datatable-border-color)}#table ::ng-deep .mat-mdc-table-sticky{opacity:1;background:var(--ngx-mat-datatable-sticky-background, var(--ngx-mat-datatable-background, #ffffff))}#table ::ng-deep .mat-mdc-table-sticky.mat-mdc-table-sticky-border-elem-left{border-right:var(--ngx-mat-datatable-sticky-border)}#table ::ng-deep .mat-mdc-header-cell{padding:0 8px}#table ::ng-deep .mat-mdc-header-cell mat-form-field{min-width:auto;flex:1 1 100%;--mdc-filled-text-field-active-indicator-color: #999;--mat-form-field-hover-state-layer-opacity: 0;--mdc-filled-text-field-container-shape: 0;--mdc-filled-text-field-container-color: var(--ngx-mat-datatable-background)}#table ::ng-deep .mat-mdc-header-cell mat-form-field ::ng-deep .mat-mdc-form-field-bottom-align{display:none}#table ::ng-deep .mat-mdc-header-cell mat-form-field ::ng-deep .mat-mdc-text-field-wrapper{padding:0}#table ::ng-deep .mat-mdc-cell{padding:0 8px}#table ::ng-deep .mat-mdc-row.has-click{cursor:pointer}#table ::ng-deep .mat-mdc-row.has-click:hover .mat-mdc-cell{color:var(--ngx-mat-datatable-hover-color, var(--mat-sys-on-primary))!important;background-color:var(--ngx-mat-datatable-hover-bgcolor, var(--mat-sys-primary))!important}#table ::ng-deep .mat-mdc-row:last-child .mat-mdc-cell{border-bottom-color:var(--mat-table-row-item-outline-color, var(--mat-sys-outline, rgba(0, 0, 0, .12)));border-bottom-width:var(--mat-table-row-item-outline-width, 1px);border-bottom-style:solid}#table .header-container{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row;width:100%;min-height:var(--mat-form-field-container-height, 56px);margin:6px 0}#table .header{width:100%;display:flex;box-sizing:border-box;place-content:center space-between;align-items:center;flex-direction:row}#table .header .header-actions .sort-btn{--mat-badge-container-size: 12px;--mat-badge-line-height: 16px;--mat-badge-text-size: 10px;--mat-badge-legacy-container-size: 18px}#table .cell{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row;width:100%}#table .cell>*{display:inline-flex}#paginator{--mat-paginator-container-background-color: var(--ngx-mat-datatable-background);--mat-form-field-container-height: 24px;--mat-form-field-container-vertical-padding: 4px;--mat-paginator-container-size: 46px;border-top:1px solid var(--ngx-mat-datatable-border-color)}#paginator ::ng-deep .mat-mdc-select{display:flex;height:24px}#paginator ::ng-deep .mat-mdc-paginator-touch-target{height:24px}#paginator ::ng-deep .mat-mdc-paginator-range-actions button{--mdc-icon-button-state-layer-size: 36px;padding:6px}#loading{position:absolute;z-index:200;inset:0;background-color:#00000029;display:flex;box-sizing:border-box;place-content:center center;align-items:center;flex-direction:row}::ng-deep .mat-mdc-icon-button[mat-icon-button][size=small]{--mdc-icon-button-state-layer-size: 30px;--mdc-icon-button-icon-size: 18px}::ng-deep .mat-mdc-icon-button[mat-icon-button][size=small] .mat-mdc-button-touch-target{height:36px;width:36px}::ng-deep .mat-mdc-icon-button[mat-icon-button][size=small] mat-icon{height:18px;width:18px;font-size:18px}.row{display:flex;box-sizing:border-box;place-content:center start;align-items:center;flex-direction:row}#no-data{position:sticky;width:fit-content;left:50%}#no-data #no-data-label{position:relative;margin-left:-50%}.facet{margin:8px;--mdc-elevated-card-container-color: transparent}.facet mat-card-content{display:flex;box-sizing:border-box;place-content:center center;align-items:center;flex-direction:row;flex-wrap:wrap;padding:4px}.facet .facet-indicator{display:flex;box-sizing:border-box;flex-direction:column;place-content:center center;align-items:center;position:relative;margin:4px}.facet .facet-indicator.has-action{cursor:pointer}.facet .facet-indicator .facet-indicator-label{max-width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;line-height:1em;padding:2px}\n"] }]
            }], ctorParameters: null, propDecorators: { options: [{
                    type: Input,
                    args: ['options']
                }], config: [{
                    type: Input
                }], rowClicked: [{
                    type: Output
                }], configUpdated: [{
                    type: Output
                }], paginator: [{
                    type: ViewChild,
                    args: [MatPaginator]
                }], contentRefs: [{
                    type: ContentChildren,
                    args: [NgxMatDatatableContentDirective]
                }] } }) });

/** @format */
class NgxMatDatatableModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatableModule, imports: [NgxMatDatatableComponent, NgxMatDatatableContentDirective], exports: [NgxMatDatatableComponent, NgxMatDatatableContentDirective] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatableModule, providers: [NgxMatDatatableIntl], imports: [NgxMatDatatableComponent] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.4", ngImport: i0, type: NgxMatDatatableModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgxMatDatatableComponent, NgxMatDatatableContentDirective],
                    exports: [NgxMatDatatableComponent, NgxMatDatatableContentDirective],
                    providers: [NgxMatDatatableIntl],
                }]
        }] });

/** @format */

/** @format */

/** @format */

/** @format */

/** @format */

/**
 * Public API Surface of mongoose-datatable
 *
 * @format
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxMatDatatableModule as N, SelectOptionPipe as S, SafeHtmlPipe as a, NgxMatDatatableComponent as b, NgxMatDatatableContentDirective as c, duration as d, NgxMatDatatableIntl as e, get as g };
//# sourceMappingURL=eherve-angular-material-datatable-eherve-angular-material-datatable-PWxHXOMs.mjs.map
