import { AfterViewInit, OnInit } from '@angular/core';
import { ControlValueAccessor, FormControl } from '@angular/forms';
import * as i0 from "@angular/core";
export type TIME_UNIT = 'second' | 'minute' | 'hour' | 'day' | 'month' | 'year';
export declare class TimeUnitSelectComponent implements OnInit, AfterViewInit, ControlValueAccessor {
    static toMilliseconds(value: number, unit: TIME_UNIT): number;
    static convert(value: number, from: TIME_UNIT, to?: TIME_UNIT): number;
    set setLocale(locale: string | undefined);
    locale?: string;
    units: TIME_UNIT[];
    unitNames: {
        [key: string]: string;
    };
    isOpen: boolean;
    control?: FormControl<any>;
    onChange: () => void;
    onTouched: () => void;
    private injector;
    private changeDetectorRef;
    writeValue: () => void;
    registerOnChange(onChange: any): void;
    registerOnTouched(onTouched: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): Promise<void>;
    private loadUnitNames;
    static ɵfac: i0.ɵɵFactoryDeclaration<TimeUnitSelectComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TimeUnitSelectComponent, "lib-time-unit-select", never, { "setLocale": { "alias": "locale"; "required": false; }; }, {}, never, never, true, never>;
}
