import { CdkDragDrop } from '@angular/cdk/drag-drop';
import { EventEmitter, OnDestroy, OnInit, QueryList } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { MatPaginator } from '@angular/material/paginator';
import { DatagridDataSource } from './datasource';
import { NgxMatDatatableIntl } from './datatable.intl';
import { NgxMatDatatableContentDirective } from './directives/datatable-cell.directive';
import { NgxMatDatasourceResultFacet } from './types/datasource-service.type';
import { DatatableColumn } from './types/datatable-column.type';
import { NgxMatDatatableOptions } from './types/datatable-options.type';
import { DatatableConfig } from './types/config.type';
import * as i0 from "@angular/core";
type UpdateColumn<Record> = Pick<DatatableColumn<Record>, 'columnDef' | 'header' | 'sticky' | 'hidden'>;
export declare class NgxMatDatatableComponent<Record = any> implements OnInit, OnDestroy {
    options: NgxMatDatatableOptions<Record>;
    config?: DatatableConfig;
    rowClicked: EventEmitter<Record>;
    configUpdated: EventEmitter<DatatableConfig>;
    paginator: MatPaginator | undefined;
    contentRefs?: QueryList<NgxMatDatatableContentDirective>;
    displayedColumns: string[];
    dataSource: DatagridDataSource<Record>;
    loaded: boolean;
    searchFormGroup: FormGroup;
    datatableIntl: NgxMatDatatableIntl;
    private subscriptions;
    private changeDetectorRef;
    ngOnInit(): Promise<void>;
    ngOnDestroy(): void;
    load(intersect: boolean): void;
    sortColumn(column: DatatableColumn<Record>): void;
    redraw(match?: (record: Record) => boolean): void;
    exporting: boolean;
    export(): Promise<void>;
    private buildExportSelectColumn;
    private buildExportDurationColumn;
    loadPage(): void;
    private buildOrder;
    updateColumns: UpdateColumn<Record>[];
    openUpdateColumnDisplay(): void;
    reorderColumns(event: CdkDragDrop<any[]>): void;
    closeUpdateColumnDisplay(): void;
    rowClick(row: Record): void;
    facetClick(column: DatatableColumn<Record> | undefined, result: NgxMatDatasourceResultFacet): void;
    private buildRequestColumns;
    private addAdditionalColumn;
    private buildDisplayColumns;
    private buildSearchFormGroup;
    private consolidateOrderIndex;
    private applyConfig;
    private updateConfig;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxMatDatatableComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxMatDatatableComponent<any>, "ngx-mat-datatable", never, { "options": { "alias": "options"; "required": false; }; "config": { "alias": "config"; "required": false; }; }, { "rowClicked": "rowClicked"; "configUpdated": "configUpdated"; }, ["contentRefs"], ["[loader-spinner]"], true, never>;
}
export {};
